/* applet.c generated by valac 0.12.0, the Vala compiler
 * generated from applet.vala, do not modify */

/*
 * Copyright (C) 2009 Michal Hruby <michal.mhr@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 * Author : Michal Hruby <michal.mhr@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <config.h>
#include <gio/gio.h>
#include <dbus/dbus-glib.h>
#include <dbus/dbus-glib-lowlevel.h>
#include <dbus/dbus.h>
#include <libawn/libawn.h>
#include <libdesktop-agnostic/config.h>
#include <gtk/gtk.h>
#include <libwnck/libwnck.h>
#include <gdk/gdk.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <glib/gi18n.h>
#include <libawn/awn-utils.h>
#include <float.h>
#include <math.h>


#define TYPE_DOCK_MANAGER (dock_manager_get_type ())
#define DOCK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DOCK_MANAGER, DockManager))
#define IS_DOCK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DOCK_MANAGER))
#define DOCK_MANAGER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_DOCK_MANAGER, DockManagerIface))

typedef struct _DockManager DockManager;
typedef struct _DockManagerIface DockManagerIface;
typedef struct _DBusObjectVTable _DBusObjectVTable;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _DockManagerDBusProxy DockManagerDBusProxy;
typedef DBusGProxyClass DockManagerDBusProxyClass;
typedef struct _DockManagerDBusProxyGetCapabilitiesData DockManagerDBusProxyGetCapabilitiesData;
typedef struct _DockManagerDBusProxyAwnSetVisibilityData DockManagerDBusProxyAwnSetVisibilityData;

#define TYPE_PREFS_APPLET (prefs_applet_get_type ())
#define PREFS_APPLET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFS_APPLET, PrefsApplet))
#define PREFS_APPLET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFS_APPLET, PrefsAppletClass))
#define IS_PREFS_APPLET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFS_APPLET))
#define IS_PREFS_APPLET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFS_APPLET))
#define PREFS_APPLET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFS_APPLET, PrefsAppletClass))

typedef struct _PrefsApplet PrefsApplet;
typedef struct _PrefsAppletClass PrefsAppletClass;
typedef struct _PrefsAppletPrivate PrefsAppletPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define _dbus_g_connection_unref0(var) ((var == NULL) ? NULL : (var = (dbus_g_connection_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _PrefsAppletUpdateTaskmanagerData PrefsAppletUpdateTaskmanagerData;

struct _DockManagerIface {
	GTypeInterface parent_iface;
	void (*get_capabilities) (DockManager* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gchar** (*get_capabilities_finish) (DockManager* self, GAsyncResult* _res_, int* result_length1, GError** error);
	void (*awn_set_visibility) (DockManager* self, const gchar* win_class, gboolean visible, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*awn_set_visibility_finish) (DockManager* self, GAsyncResult* _res_, GError** error);
};

struct _DBusObjectVTable {
	void (*register_object) (DBusConnection*, const char*, void*);
};

struct _DockManagerDBusProxy {
	DBusGProxy parent_instance;
	gboolean disposed;
};

struct _DockManagerDBusProxyGetCapabilitiesData {
	GAsyncReadyCallback _callback_;
	gpointer _user_data_;
	DBusPendingCall* pending;
};

struct _DockManagerDBusProxyAwnSetVisibilityData {
	GAsyncReadyCallback _callback_;
	gpointer _user_data_;
	DBusPendingCall* pending;
};

struct _PrefsApplet {
	AwnAppletSimple parent_instance;
	PrefsAppletPrivate * priv;
};

struct _PrefsAppletClass {
	AwnAppletSimpleClass parent_class;
};

struct _PrefsAppletPrivate {
	DesktopAgnosticConfigClient* panel_client;
	GtkMenu* ctx_menu;
	GList* windows;
	guint timer_id;
	gboolean in_drag;
	guint autohide_cookie;
	AwnApplet* docklet;
	GList* docklet_icons;
};

struct _PrefsAppletUpdateTaskmanagerData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	PrefsApplet* self;
	gboolean visible;
	DBusGConnection* _tmp0_;
	DBusGConnection* con;
	DockManager* taskman;
	gint _tmp1_;
	gchar** _tmp2_;
	gchar** caps;
	gint caps_length1;
	gint _caps_size_;
	gboolean supports_visibility_setting;
	gchar** cap_collection;
	int cap_collection_length1;
	int cap_it;
	gchar* _tmp3_;
	gchar* cap;
	GError * err;
	GError * _inner_error_;
};


static gpointer prefs_applet_parent_class = NULL;

#define not_used APPLETSDIR
DockManager* dock_manager_dbus_proxy_new (DBusGConnection* connection, const char* name, const char* path);
GType dock_manager_get_type (void) G_GNUC_CONST;
void dock_manager_get_capabilities (DockManager* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
gchar** dock_manager_get_capabilities_finish (DockManager* self, GAsyncResult* _res_, int* result_length1, GError** error);
void dock_manager_awn_set_visibility (DockManager* self, const gchar* win_class, gboolean visible, GAsyncReadyCallback _callback_, gpointer _user_data_);
void dock_manager_awn_set_visibility_finish (DockManager* self, GAsyncResult* _res_, GError** error);
static void _vala_dbus_register_object (DBusConnection* connection, const char* path, void* object);
static void _vala_dbus_unregister_object (gpointer connection, GObject* object);
void dock_manager_dbus_register_object (DBusConnection* connection, const char* path, void* object);
void _dock_manager_dbus_unregister (DBusConnection* connection, void* _user_data_);
DBusHandlerResult dock_manager_dbus_message (DBusConnection* connection, DBusMessage* message, void* object);
static DBusHandlerResult _dbus_dock_manager_introspect (DockManager* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_dock_manager_property_get_all (DockManager* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_dock_manager_get_capabilities (DockManager* self, DBusConnection* connection, DBusMessage* message);
static void _dbus_dock_manager_get_capabilities_ready (GObject * source_object, GAsyncResult * _res_, gpointer * _user_data_);
static DBusHandlerResult _dbus_dock_manager_awn_set_visibility (DockManager* self, DBusConnection* connection, DBusMessage* message);
static void _dbus_dock_manager_awn_set_visibility_ready (GObject * source_object, GAsyncResult * _res_, gpointer * _user_data_);
GType dock_manager_dbus_proxy_get_type (void) G_GNUC_CONST;
DBusHandlerResult dock_manager_dbus_proxy_filter (DBusConnection* connection, DBusMessage* message, void* user_data);
enum  {
	DOCK_MANAGER_DBUS_PROXY_DUMMY_PROPERTY
};
static void dock_manager_dbus_proxy_get_capabilities_async (DockManager* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void dock_manager_dbus_proxy_get_capabilities_ready (DBusPendingCall* pending, void* user_data);
static gchar** dock_manager_dbus_proxy_get_capabilities_finish (DockManager* self, GAsyncResult* _res_, int* result_length1, GError** error);
static void dock_manager_dbus_proxy_awn_set_visibility_async (DockManager* self, const gchar* win_class, gboolean visible, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void dock_manager_dbus_proxy_awn_set_visibility_ready (DBusPendingCall* pending, void* user_data);
static void dock_manager_dbus_proxy_awn_set_visibility_finish (DockManager* self, GAsyncResult* _res_, GError** error);
static void dock_manager_dbus_proxy_dock_manager__interface_init (DockManagerIface* iface);
static void _vala_dock_manager_dbus_proxy_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_dock_manager_dbus_proxy_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType prefs_applet_get_type (void) G_GNUC_CONST;
#define PREFS_APPLET_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PREFS_APPLET, PrefsAppletPrivate))
enum  {
	PREFS_APPLET_DUMMY_PROPERTY
};
PrefsApplet* prefs_applet_new (const gchar* canonical_name, const gchar* uid, gint panel_id);
PrefsApplet* prefs_applet_construct (GType object_type, const gchar* canonical_name, const gchar* uid, gint panel_id);
static void prefs_applet_real_constructed (GObject* base);
static void prefs_applet_on_clicked (PrefsApplet* self);
static void _prefs_applet_on_clicked_awn_icon_clicked (AwnIcon* _sender, gpointer self);
static void prefs_applet_on_context_menu_popup (PrefsApplet* self, GdkEventButton* evt);
static void _prefs_applet_on_context_menu_popup_awn_icon_context_menu_popup (AwnIcon* _sender, GdkEventButton* event, gpointer self);
static void prefs_applet_on_drag_begin (PrefsApplet* self, GdkDragContext* context);
static void _prefs_applet_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender, GdkDragContext* context, gpointer self);
static void prefs_applet_on_drag_end (PrefsApplet* self, GdkDragContext* context);
static void _prefs_applet_on_drag_end_gtk_widget_drag_end (GtkWidget* _sender, GdkDragContext* context, gpointer self);
static gboolean prefs_applet_on_drag_failed (PrefsApplet* self, GdkDragContext* context, GtkDragResult _result_);
static gboolean _prefs_applet_on_drag_failed_gtk_widget_drag_failed (GtkWidget* _sender, GdkDragContext* p0, GtkDragResult p1, gpointer self);
static void prefs_applet_initialize_menu (PrefsApplet* self);
static void prefs_applet_taskmanager_appeared (PrefsApplet* self, const gchar* name);
static void _prefs_applet_taskmanager_appeared_awn_dbus_watcher_name_appeared (AwnDBusWatcher* _sender, const gchar* name, gpointer self);
static void prefs_applet_update_taskmanager (PrefsApplet* self, gboolean visible, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void prefs_applet_update_taskmanager_finish (PrefsApplet* self, GAsyncResult* _res_);
static void _lambda10_ (AwnApplet* w, PrefsApplet* self);
static void __lambda10__awn_applet_applet_deleted (AwnApplet* _sender, gpointer self);
static void prefs_applet_on_quit_click (PrefsApplet* self);
static void _prefs_applet_on_quit_click_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void _lambda9_ (GtkMenuItem* w, PrefsApplet* self);
static void prefs_applet_run_preferences (PrefsApplet* self, gboolean about_only);
static void __lambda9__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void prefs_applet_update_taskmanager_data_free (gpointer _data);
static gboolean prefs_applet_update_taskmanager_co (PrefsAppletUpdateTaskmanagerData* data);
static void prefs_applet_update_taskmanager_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static void prefs_applet_on_active_changed (PrefsApplet* self, WnckWindow* old_active);
static void prefs_applet_on_window_opened (PrefsApplet* self, WnckWindow* window);
static void prefs_applet_update_icon (PrefsApplet* self);
static void prefs_applet_on_window_closed (PrefsApplet* self, WnckWindow* window);
static gboolean prefs_applet_on_timer_tick (PrefsApplet* self);
static gboolean _prefs_applet_on_timer_tick_gsource_func (gpointer self);
void prefs_applet_setup_docklet (PrefsApplet* self, GdkNativeWindow window_id);
void prefs_applet_setup_label_for_docklet (AwnLabel* label, AwnApplet* docklet);
static AwnIcon* prefs_applet_new_unbound_icon (void);
static void _lambda0_ (GtkObject* w, PrefsApplet* self);
static void __lambda0__gtk_object_destroy (GtkObject* _sender, gpointer self);
static void _lambda1_ (AwnApplet* w, gint s, PrefsApplet* self);
static void __lambda1__awn_applet_size_changed (AwnApplet* _sender, gint size, gpointer self);
static void _lambda2_ (AwnApplet* w, GtkPositionType p, PrefsApplet* self);
static void __lambda2__awn_applet_position_changed (AwnApplet* _sender, GtkPositionType position, gpointer self);
static void _lambda3_ (AwnIcon* w, PrefsApplet* self);
static void __lambda3__awn_icon_clicked (AwnIcon* _sender, gpointer self);
static void _lambda4_ (AwnIcon* w, PrefsApplet* self);
static void prefs_applet_change_icon_size (PrefsApplet* self, gint new_size);
static void __lambda4__awn_icon_clicked (AwnIcon* _sender, gpointer self);
static void _lambda5_ (AwnIcon* w, PrefsApplet* self);
static void __lambda5__awn_icon_clicked (AwnIcon* _sender, gpointer self);
static void _lambda6_ (AwnIcon* w, PrefsApplet* self);
static void __lambda6__awn_icon_clicked (AwnIcon* _sender, gpointer self);
static void _lambda7_ (AwnIcon* w, PrefsApplet* self);
static void __lambda7__awn_icon_clicked (AwnIcon* _sender, gpointer self);
static void _lambda8_ (AwnIcon* w, PrefsApplet* self);
static void __lambda8__awn_icon_clicked (AwnIcon* _sender, gpointer self);
static void _dynamic_RemovePanel0 (DBusGProxy* self, gint param1, GError** error);
static GObject * prefs_applet_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void _prefs_applet_on_window_opened_wnck_screen_window_opened (WnckScreen* _sender, WnckWindow* window, gpointer self);
static void _prefs_applet_on_window_closed_wnck_screen_window_closed (WnckScreen* _sender, WnckWindow* window, gpointer self);
static void _prefs_applet_on_active_changed_wnck_screen_active_window_changed (WnckScreen* _sender, WnckWindow* previous_window, gpointer self);
static void prefs_applet_finalize (GObject* obj);
AwnApplet* awn_applet_factory_initp (const gchar* canonical_name, const gchar* uid, gint panel_id);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const DBusObjectPathVTable _dock_manager_dbus_path_vtable = {_dock_manager_dbus_unregister, dock_manager_dbus_message};
static const _DBusObjectVTable _dock_manager_dbus_vtable = {dock_manager_dbus_register_object};
static const GtkTargetEntry PREFS_APPLET_targets[1] = {{"awn/awn-panel", (guint) GTK_TARGET_SAME_WIDGET, (guint) 0}};

void dock_manager_get_capabilities (DockManager* self, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DOCK_MANAGER_GET_INTERFACE (self)->get_capabilities (self, _callback_, _user_data_);
}


gchar** dock_manager_get_capabilities_finish (DockManager* self, GAsyncResult* _res_, int* result_length1, GError** error) {
	return DOCK_MANAGER_GET_INTERFACE (self)->get_capabilities_finish (self, _res_, result_length1, error);
}


void dock_manager_awn_set_visibility (DockManager* self, const gchar* win_class, gboolean visible, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DOCK_MANAGER_GET_INTERFACE (self)->awn_set_visibility (self, win_class, visible, _callback_, _user_data_);
}


void dock_manager_awn_set_visibility_finish (DockManager* self, GAsyncResult* _res_, GError** error) {
	DOCK_MANAGER_GET_INTERFACE (self)->awn_set_visibility_finish (self, _res_, error);
}


static void dock_manager_base_init (DockManagerIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


static void _vala_dbus_register_object (DBusConnection* connection, const char* path, void* object) {
	const _DBusObjectVTable * vtable;
	vtable = g_type_get_qdata (G_TYPE_FROM_INSTANCE (object), g_quark_from_static_string ("DBusObjectVTable"));
	if (vtable) {
		vtable->register_object (connection, path, object);
	} else {
		g_warning ("Object does not implement any D-Bus interface");
	}
}


static void _vala_dbus_unregister_object (gpointer connection, GObject* object) {
	char* path;
	path = g_object_steal_data ((GObject*) object, "dbus_object_path");
	dbus_connection_unregister_object_path (connection, path);
	g_free (path);
}


void _dock_manager_dbus_unregister (DBusConnection* connection, void* _user_data_) {
}


static DBusHandlerResult _dbus_dock_manager_introspect (DockManager* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessage* reply;
	DBusMessageIter iter;
	GString* xml_data;
	char** children;
	int i;
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	xml_data = g_string_new ("<!DOCTYPE node PUBLIC \"-//freedesktop//DTD D-BUS Object Introspection 1.0//EN\" \"http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd\">\n");
	g_string_append (xml_data, "<node>\n<interface name=\"org.freedesktop.DBus.Introspectable\">\n  <method name=\"Introspect\">\n    <arg name=\"data\" direction=\"out\" type=\"s\"/>\n  </method>\n</interface>\n<interface name=\"org.freedesktop.DBus.Properties\">\n  <method name=\"Get\">\n    <arg name=\"interface\" direction=\"in\" type=\"s\"/>\n    <arg name=\"propname\" direction=\"in\" type=\"s\"/>\n    <arg name=\"value\" direction=\"out\" type=\"v\"/>\n  </method>\n  <method name=\"Set\">\n    <arg name=\"interface\" direction=\"in\" type=\"s\"/>\n    <arg name=\"propname\" direction=\"in\" type=\"s\"/>\n    <arg name=\"value\" direction=\"in\" type=\"v\"/>\n  </method>\n  <method name=\"GetAll\">\n    <arg name=\"interface\" direction=\"in\" type=\"s\"/>\n    <arg name=\"props\" direction=\"out\" type=\"a{sv}\"/>\n  </method>\n</interface>\n<interface name=\"net.launchpad.DockManager\">\n  <method name=\"GetCapabilities\">\n    <arg name=\"result\" type=\"as\" direction=\"out\"/>\n  </method>\n  <method name=\"AwnSetVisibility\">\n    <arg name=\"win_class\" type=\"s\" direction=\"in\"/>\n    <arg name=\"visible\" type=\"b\" direction=\"in\"/>\n  </method>\n</interface>\n");
	dbus_connection_list_registered (connection, g_object_get_data ((GObject *) self, "dbus_object_path"), &children);
	for (i = 0; children[i]; i++) {
		g_string_append_printf (xml_data, "<node name=\"%s\"/>\n", children[i]);
	}
	dbus_free_string_array (children);
	g_string_append (xml_data, "</node>\n");
	dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &xml_data->str);
	g_string_free (xml_data, TRUE);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_dock_manager_property_get_all (DockManager* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessage* reply;
	DBusMessageIter iter, reply_iter, subiter;
	char* interface_name;
	const char* _tmp0_;
	if (strcmp (dbus_message_get_signature (message), "s")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &reply_iter);
	dbus_message_iter_get_basic (&iter, &_tmp0_);
	dbus_message_iter_next (&iter);
	interface_name = g_strdup (_tmp0_);
	if (strcmp (interface_name, "net.launchpad.DockManager") == 0) {
		dbus_message_iter_open_container (&reply_iter, DBUS_TYPE_ARRAY, "{sv}", &subiter);
		dbus_message_iter_close_container (&reply_iter, &subiter);
	} else {
		dbus_message_unref (reply);
		reply = NULL;
	}
	g_free (interface_name);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_dock_manager_get_capabilities (DockManager* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	gpointer * _user_data_;
	if (strcmp (dbus_message_get_signature (message), "")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	_user_data_ = g_new0 (gpointer, 2);
	_user_data_[0] = dbus_connection_ref (connection);
	_user_data_[1] = dbus_message_ref (message);
	dock_manager_get_capabilities (self, (GAsyncReadyCallback) _dbus_dock_manager_get_capabilities_ready, _user_data_);
	return DBUS_HANDLER_RESULT_HANDLED;
}


static void _dbus_dock_manager_get_capabilities_ready (GObject * source_object, GAsyncResult * _res_, gpointer * _user_data_) {
	DBusConnection * connection;
	DBusMessage * message;
	DBusMessageIter iter;
	GError* error;
	gchar** result;
	int result_length1;
	DBusMessage* reply;
	gchar** _tmp1_;
	DBusMessageIter _tmp2_;
	int _tmp3_;
	connection = _user_data_[0];
	message = _user_data_[1];
	error = NULL;
	result_length1 = 0;
	result = dock_manager_get_capabilities_finish ((DockManager*) source_object, _res_, &result_length1, &error);
	if (error) {
		if (error->domain == DBUS_GERROR) {
			switch (error->code) {
				case DBUS_GERROR_FAILED:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.Failed", error->message);
				break;
				case DBUS_GERROR_NO_MEMORY:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.NoMemory", error->message);
				break;
				case DBUS_GERROR_SERVICE_UNKNOWN:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.ServiceUnknown", error->message);
				break;
				case DBUS_GERROR_NAME_HAS_NO_OWNER:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.NameHasNoOwner", error->message);
				break;
				case DBUS_GERROR_NO_REPLY:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.NoReply", error->message);
				break;
				case DBUS_GERROR_IO_ERROR:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.IOError", error->message);
				break;
				case DBUS_GERROR_BAD_ADDRESS:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.BadAddress", error->message);
				break;
				case DBUS_GERROR_NOT_SUPPORTED:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.NotSupported", error->message);
				break;
				case DBUS_GERROR_LIMITS_EXCEEDED:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.LimitsExceeded", error->message);
				break;
				case DBUS_GERROR_ACCESS_DENIED:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.AccessDenied", error->message);
				break;
				case DBUS_GERROR_AUTH_FAILED:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.AuthFailed", error->message);
				break;
				case DBUS_GERROR_NO_SERVER:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.NoServer", error->message);
				break;
				case DBUS_GERROR_TIMEOUT:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.Timeout", error->message);
				break;
				case DBUS_GERROR_NO_NETWORK:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.NoNetwork", error->message);
				break;
				case DBUS_GERROR_ADDRESS_IN_USE:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.AddressInUse", error->message);
				break;
				case DBUS_GERROR_DISCONNECTED:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.Disconnected", error->message);
				break;
				case DBUS_GERROR_INVALID_ARGS:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.InvalidArgs", error->message);
				break;
				case DBUS_GERROR_FILE_NOT_FOUND:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.FileNotFound", error->message);
				break;
				case DBUS_GERROR_FILE_EXISTS:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.FileExists", error->message);
				break;
				case DBUS_GERROR_UNKNOWN_METHOD:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.UnknownMethod", error->message);
				break;
				case DBUS_GERROR_TIMED_OUT:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.TimedOut", error->message);
				break;
				case DBUS_GERROR_MATCH_RULE_NOT_FOUND:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.MatchRuleNotFound", error->message);
				break;
				case DBUS_GERROR_MATCH_RULE_INVALID:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.MatchRuleInvalid", error->message);
				break;
				case DBUS_GERROR_SPAWN_EXEC_FAILED:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.Spawn.ExecFailed", error->message);
				break;
				case DBUS_GERROR_SPAWN_FORK_FAILED:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.Spawn.ForkFailed", error->message);
				break;
				case DBUS_GERROR_SPAWN_CHILD_EXITED:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.Spawn.ChildExited", error->message);
				break;
				case DBUS_GERROR_SPAWN_CHILD_SIGNALED:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.Spawn.ChildSignaled", error->message);
				break;
				case DBUS_GERROR_SPAWN_FAILED:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.Spawn.Failed", error->message);
				break;
				case DBUS_GERROR_UNIX_PROCESS_ID_UNKNOWN:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.UnixProcessIdUnknown", error->message);
				break;
				case DBUS_GERROR_INVALID_SIGNATURE:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.InvalidSignature", error->message);
				break;
				case DBUS_GERROR_INVALID_FILE_CONTENT:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.InvalidFileContent", error->message);
				break;
				case DBUS_GERROR_SELINUX_SECURITY_CONTEXT_UNKNOWN:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.SELinuxSecurityContextUnknown", error->message);
				break;
				case DBUS_GERROR_REMOTE_EXCEPTION:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.RemoteException", error->message);
				break;
			}
		}
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return;
	}
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	_tmp1_ = result;
	dbus_message_iter_open_container (&iter, DBUS_TYPE_ARRAY, "s", &_tmp2_);
	for (_tmp3_ = 0; _tmp3_ < result_length1; _tmp3_++) {
		const char* _tmp4_;
		_tmp4_ = *_tmp1_;
		dbus_message_iter_append_basic (&_tmp2_, DBUS_TYPE_STRING, &_tmp4_);
		_tmp1_++;
	}
	dbus_message_iter_close_container (&iter, &_tmp2_);
	 result = (_vala_array_free ( result,  result_length1, (GDestroyNotify) g_free), NULL);
	dbus_connection_send (connection, reply, NULL);
	dbus_message_unref (reply);
	dbus_connection_unref (connection);
	dbus_message_unref (message);
	g_free (_user_data_);
}


static DBusHandlerResult _dbus_dock_manager_awn_set_visibility (DockManager* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	gchar* win_class = NULL;
	const char* _tmp5_;
	gboolean visible = FALSE;
	dbus_bool_t _tmp6_;
	gpointer * _user_data_;
	if (strcmp (dbus_message_get_signature (message), "sb")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	dbus_message_iter_get_basic (&iter, &_tmp5_);
	dbus_message_iter_next (&iter);
	win_class = g_strdup (_tmp5_);
	dbus_message_iter_get_basic (&iter, &_tmp6_);
	dbus_message_iter_next (&iter);
	visible = _tmp6_;
	_user_data_ = g_new0 (gpointer, 2);
	_user_data_[0] = dbus_connection_ref (connection);
	_user_data_[1] = dbus_message_ref (message);
	dock_manager_awn_set_visibility (self, win_class, visible, (GAsyncReadyCallback) _dbus_dock_manager_awn_set_visibility_ready, _user_data_);
	_g_free0 (win_class);
	return DBUS_HANDLER_RESULT_HANDLED;
}


static void _dbus_dock_manager_awn_set_visibility_ready (GObject * source_object, GAsyncResult * _res_, gpointer * _user_data_) {
	DBusConnection * connection;
	DBusMessage * message;
	DBusMessageIter iter;
	GError* error;
	DBusMessage* reply;
	connection = _user_data_[0];
	message = _user_data_[1];
	error = NULL;
	dock_manager_awn_set_visibility_finish ((DockManager*) source_object, _res_, &error);
	if (error) {
		if (error->domain == DBUS_GERROR) {
			switch (error->code) {
				case DBUS_GERROR_FAILED:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.Failed", error->message);
				break;
				case DBUS_GERROR_NO_MEMORY:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.NoMemory", error->message);
				break;
				case DBUS_GERROR_SERVICE_UNKNOWN:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.ServiceUnknown", error->message);
				break;
				case DBUS_GERROR_NAME_HAS_NO_OWNER:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.NameHasNoOwner", error->message);
				break;
				case DBUS_GERROR_NO_REPLY:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.NoReply", error->message);
				break;
				case DBUS_GERROR_IO_ERROR:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.IOError", error->message);
				break;
				case DBUS_GERROR_BAD_ADDRESS:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.BadAddress", error->message);
				break;
				case DBUS_GERROR_NOT_SUPPORTED:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.NotSupported", error->message);
				break;
				case DBUS_GERROR_LIMITS_EXCEEDED:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.LimitsExceeded", error->message);
				break;
				case DBUS_GERROR_ACCESS_DENIED:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.AccessDenied", error->message);
				break;
				case DBUS_GERROR_AUTH_FAILED:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.AuthFailed", error->message);
				break;
				case DBUS_GERROR_NO_SERVER:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.NoServer", error->message);
				break;
				case DBUS_GERROR_TIMEOUT:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.Timeout", error->message);
				break;
				case DBUS_GERROR_NO_NETWORK:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.NoNetwork", error->message);
				break;
				case DBUS_GERROR_ADDRESS_IN_USE:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.AddressInUse", error->message);
				break;
				case DBUS_GERROR_DISCONNECTED:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.Disconnected", error->message);
				break;
				case DBUS_GERROR_INVALID_ARGS:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.InvalidArgs", error->message);
				break;
				case DBUS_GERROR_FILE_NOT_FOUND:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.FileNotFound", error->message);
				break;
				case DBUS_GERROR_FILE_EXISTS:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.FileExists", error->message);
				break;
				case DBUS_GERROR_UNKNOWN_METHOD:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.UnknownMethod", error->message);
				break;
				case DBUS_GERROR_TIMED_OUT:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.TimedOut", error->message);
				break;
				case DBUS_GERROR_MATCH_RULE_NOT_FOUND:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.MatchRuleNotFound", error->message);
				break;
				case DBUS_GERROR_MATCH_RULE_INVALID:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.MatchRuleInvalid", error->message);
				break;
				case DBUS_GERROR_SPAWN_EXEC_FAILED:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.Spawn.ExecFailed", error->message);
				break;
				case DBUS_GERROR_SPAWN_FORK_FAILED:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.Spawn.ForkFailed", error->message);
				break;
				case DBUS_GERROR_SPAWN_CHILD_EXITED:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.Spawn.ChildExited", error->message);
				break;
				case DBUS_GERROR_SPAWN_CHILD_SIGNALED:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.Spawn.ChildSignaled", error->message);
				break;
				case DBUS_GERROR_SPAWN_FAILED:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.Spawn.Failed", error->message);
				break;
				case DBUS_GERROR_UNIX_PROCESS_ID_UNKNOWN:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.UnixProcessIdUnknown", error->message);
				break;
				case DBUS_GERROR_INVALID_SIGNATURE:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.InvalidSignature", error->message);
				break;
				case DBUS_GERROR_INVALID_FILE_CONTENT:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.InvalidFileContent", error->message);
				break;
				case DBUS_GERROR_SELINUX_SECURITY_CONTEXT_UNKNOWN:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.SELinuxSecurityContextUnknown", error->message);
				break;
				case DBUS_GERROR_REMOTE_EXCEPTION:
				reply = dbus_message_new_error (message, "org.freedesktop.DBus.Error.RemoteException", error->message);
				break;
			}
		}
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return;
	}
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	dbus_connection_send (connection, reply, NULL);
	dbus_message_unref (reply);
	dbus_connection_unref (connection);
	dbus_message_unref (message);
	g_free (_user_data_);
}


DBusHandlerResult dock_manager_dbus_message (DBusConnection* connection, DBusMessage* message, void* object) {
	DBusHandlerResult result;
	result = DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	if (dbus_message_is_method_call (message, "org.freedesktop.DBus.Introspectable", "Introspect")) {
		result = _dbus_dock_manager_introspect (object, connection, message);
	} else if (dbus_message_is_method_call (message, "org.freedesktop.DBus.Properties", "GetAll")) {
		result = _dbus_dock_manager_property_get_all (object, connection, message);
	} else if (dbus_message_is_method_call (message, "net.launchpad.DockManager", "GetCapabilities")) {
		result = _dbus_dock_manager_get_capabilities (object, connection, message);
	} else if (dbus_message_is_method_call (message, "net.launchpad.DockManager", "AwnSetVisibility")) {
		result = _dbus_dock_manager_awn_set_visibility (object, connection, message);
	}
	if (result == DBUS_HANDLER_RESULT_HANDLED) {
		return result;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


void dock_manager_dbus_register_object (DBusConnection* connection, const char* path, void* object) {
	if (!g_object_get_data (object, "dbus_object_path")) {
		g_object_set_data (object, "dbus_object_path", g_strdup (path));
		dbus_connection_register_object_path (connection, path, &_dock_manager_dbus_path_vtable, object);
		g_object_weak_ref (object, _vala_dbus_unregister_object, connection);
	}
}


GType dock_manager_get_type (void) {
	static volatile gsize dock_manager_type_id__volatile = 0;
	if (g_once_init_enter (&dock_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DockManagerIface), (GBaseInitFunc) dock_manager_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType dock_manager_type_id;
		dock_manager_type_id = g_type_register_static (G_TYPE_INTERFACE, "DockManager", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (dock_manager_type_id, G_TYPE_OBJECT);
		g_type_set_qdata (dock_manager_type_id, g_quark_from_string ("ValaDBusInterfaceProxyType"), &dock_manager_dbus_proxy_get_type);
		g_type_set_qdata (dock_manager_type_id, g_quark_from_static_string ("DBusObjectVTable"), (void*) (&_dock_manager_dbus_vtable));
		g_once_init_leave (&dock_manager_type_id__volatile, dock_manager_type_id);
	}
	return dock_manager_type_id__volatile;
}


G_DEFINE_TYPE_EXTENDED (DockManagerDBusProxy, dock_manager_dbus_proxy, DBUS_TYPE_G_PROXY, 0, G_IMPLEMENT_INTERFACE (TYPE_DOCK_MANAGER, dock_manager_dbus_proxy_dock_manager__interface_init) );
DockManager* dock_manager_dbus_proxy_new (DBusGConnection* connection, const char* name, const char* path) {
	DockManager* self;
	self = g_object_new (dock_manager_dbus_proxy_get_type (), "connection", connection, "name", name, "path", path, "interface", "net.launchpad.DockManager", NULL);
	return self;
}


static GObject* dock_manager_dbus_proxy_construct (GType gtype, guint n_properties, GObjectConstructParam* properties) {
	GObject* self;
	DBusGConnection *connection;
	char* path;
	char* filter;
	self = G_OBJECT_CLASS (dock_manager_dbus_proxy_parent_class)->constructor (gtype, n_properties, properties);
	g_object_get (self, "connection", &connection, NULL);
	g_object_get (self, "path", &path, NULL);
	dbus_connection_add_filter (dbus_g_connection_get_connection (connection), dock_manager_dbus_proxy_filter, self, NULL);
	filter = g_strdup_printf ("type='signal',path='%s',interface='net.launchpad.DockManager'", path);
	dbus_bus_add_match (dbus_g_connection_get_connection (connection), filter, NULL);
	dbus_g_connection_unref (connection);
	g_free (path);
	g_free (filter);
	return self;
}


DBusHandlerResult dock_manager_dbus_proxy_filter (DBusConnection* connection, DBusMessage* message, void* user_data) {
	if (dbus_message_has_path (message, dbus_g_proxy_get_path (user_data))) {
	}
	return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
}


static void dock_manager_dbus_proxy_dispose (GObject* self) {
	DBusGConnection *connection;
	if (((DockManagerDBusProxy*) self)->disposed) {
		return;
	}
	((DockManagerDBusProxy*) self)->disposed = TRUE;
	g_object_get (self, "connection", &connection, NULL);
	dbus_connection_remove_filter (dbus_g_connection_get_connection (connection), dock_manager_dbus_proxy_filter, self);
	G_OBJECT_CLASS (dock_manager_dbus_proxy_parent_class)->dispose (self);
}


static void dock_manager_dbus_proxy_class_init (DockManagerDBusProxyClass* klass) {
	G_OBJECT_CLASS (klass)->constructor = dock_manager_dbus_proxy_construct;
	G_OBJECT_CLASS (klass)->dispose = dock_manager_dbus_proxy_dispose;
	G_OBJECT_CLASS (klass)->get_property = _vala_dock_manager_dbus_proxy_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_dock_manager_dbus_proxy_set_property;
}


static void dock_manager_dbus_proxy_init (DockManagerDBusProxy* self) {
}


static void dock_manager_dbus_proxy_get_capabilities_async (DockManager* self, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DBusGConnection *_connection;
	DBusMessage *_message;
	DBusPendingCall *_pending;
	DBusMessageIter _iter;
	DockManagerDBusProxyGetCapabilitiesData* _data_;
	_message = dbus_message_new_method_call (dbus_g_proxy_get_bus_name ((DBusGProxy*) self), dbus_g_proxy_get_path ((DBusGProxy*) self), "net.launchpad.DockManager", "GetCapabilities");
	dbus_message_iter_init_append (_message, &_iter);
	g_object_get (self, "connection", &_connection, NULL);
	dbus_connection_send_with_reply (dbus_g_connection_get_connection (_connection), _message, &_pending, -1);
	dbus_g_connection_unref (_connection);
	dbus_message_unref (_message);
	_data_ = g_slice_new0 (DockManagerDBusProxyGetCapabilitiesData);
	_data_->_callback_ = _callback_;
	_data_->_user_data_ = _user_data_;
	_data_->pending = _pending;
	dbus_pending_call_set_notify (_pending, dock_manager_dbus_proxy_get_capabilities_ready, _data_, NULL);
}


static void dock_manager_dbus_proxy_get_capabilities_ready (DBusPendingCall* pending, void* user_data) {
	DockManagerDBusProxyGetCapabilitiesData* _data_;
	GObject * _obj_;
	GSimpleAsyncResult * _res_;
	_data_ = user_data;
	_obj_ = g_object_newv (G_TYPE_OBJECT, 0, NULL);
	_res_ = g_simple_async_result_new (_obj_, _data_->_callback_, _data_->_user_data_, _data_);
	g_simple_async_result_complete (_res_);
	g_object_unref (_obj_);
	g_object_unref (_res_);
	g_slice_free (DockManagerDBusProxyGetCapabilitiesData, _data_);
	dbus_pending_call_unref (pending);
}


static gchar** dock_manager_dbus_proxy_get_capabilities_finish (DockManager* self, GAsyncResult* _res_, int* result_length1, GError** error) {
	DockManagerDBusProxyGetCapabilitiesData* _data_;
	DBusError _dbus_error;
	DBusMessage *_reply;
	DBusMessageIter _iter;
	gchar** _result;
	int _result_length1;
	gchar** _tmp4_;
	int _tmp4__length;
	int _tmp4__size;
	int _tmp4__length1;
	DBusMessageIter _tmp5_;
	_data_ = g_simple_async_result_get_source_tag ((GSimpleAsyncResult *) _res_);
	dbus_error_init (&_dbus_error);
	_reply = dbus_pending_call_steal_reply (_data_->pending);
	dbus_set_error_from_message (&_dbus_error, _reply);
	if (dbus_error_is_set (&_dbus_error)) {
		GQuark _edomain = 0;
		gint _ecode = 0;
		if (strstr (_dbus_error.name, "org.freedesktop.DBus.Error") == _dbus_error.name) {
			const char* _tmp3_;
			_edomain = DBUS_GERROR;
			_tmp3_ = _dbus_error.name + 27;
			if (strcmp (_tmp3_, "Failed") == 0) {
				_ecode = DBUS_GERROR_FAILED;
			} else if (strcmp (_tmp3_, "NoMemory") == 0) {
				_ecode = DBUS_GERROR_NO_MEMORY;
			} else if (strcmp (_tmp3_, "ServiceUnknown") == 0) {
				_ecode = DBUS_GERROR_SERVICE_UNKNOWN;
			} else if (strcmp (_tmp3_, "NameHasNoOwner") == 0) {
				_ecode = DBUS_GERROR_NAME_HAS_NO_OWNER;
			} else if (strcmp (_tmp3_, "NoReply") == 0) {
				_ecode = DBUS_GERROR_NO_REPLY;
			} else if (strcmp (_tmp3_, "IOError") == 0) {
				_ecode = DBUS_GERROR_IO_ERROR;
			} else if (strcmp (_tmp3_, "BadAddress") == 0) {
				_ecode = DBUS_GERROR_BAD_ADDRESS;
			} else if (strcmp (_tmp3_, "NotSupported") == 0) {
				_ecode = DBUS_GERROR_NOT_SUPPORTED;
			} else if (strcmp (_tmp3_, "LimitsExceeded") == 0) {
				_ecode = DBUS_GERROR_LIMITS_EXCEEDED;
			} else if (strcmp (_tmp3_, "AccessDenied") == 0) {
				_ecode = DBUS_GERROR_ACCESS_DENIED;
			} else if (strcmp (_tmp3_, "AuthFailed") == 0) {
				_ecode = DBUS_GERROR_AUTH_FAILED;
			} else if (strcmp (_tmp3_, "NoServer") == 0) {
				_ecode = DBUS_GERROR_NO_SERVER;
			} else if (strcmp (_tmp3_, "Timeout") == 0) {
				_ecode = DBUS_GERROR_TIMEOUT;
			} else if (strcmp (_tmp3_, "NoNetwork") == 0) {
				_ecode = DBUS_GERROR_NO_NETWORK;
			} else if (strcmp (_tmp3_, "AddressInUse") == 0) {
				_ecode = DBUS_GERROR_ADDRESS_IN_USE;
			} else if (strcmp (_tmp3_, "Disconnected") == 0) {
				_ecode = DBUS_GERROR_DISCONNECTED;
			} else if (strcmp (_tmp3_, "InvalidArgs") == 0) {
				_ecode = DBUS_GERROR_INVALID_ARGS;
			} else if (strcmp (_tmp3_, "FileNotFound") == 0) {
				_ecode = DBUS_GERROR_FILE_NOT_FOUND;
			} else if (strcmp (_tmp3_, "FileExists") == 0) {
				_ecode = DBUS_GERROR_FILE_EXISTS;
			} else if (strcmp (_tmp3_, "UnknownMethod") == 0) {
				_ecode = DBUS_GERROR_UNKNOWN_METHOD;
			} else if (strcmp (_tmp3_, "TimedOut") == 0) {
				_ecode = DBUS_GERROR_TIMED_OUT;
			} else if (strcmp (_tmp3_, "MatchRuleNotFound") == 0) {
				_ecode = DBUS_GERROR_MATCH_RULE_NOT_FOUND;
			} else if (strcmp (_tmp3_, "MatchRuleInvalid") == 0) {
				_ecode = DBUS_GERROR_MATCH_RULE_INVALID;
			} else if (strcmp (_tmp3_, "Spawn.ExecFailed") == 0) {
				_ecode = DBUS_GERROR_SPAWN_EXEC_FAILED;
			} else if (strcmp (_tmp3_, "Spawn.ForkFailed") == 0) {
				_ecode = DBUS_GERROR_SPAWN_FORK_FAILED;
			} else if (strcmp (_tmp3_, "Spawn.ChildExited") == 0) {
				_ecode = DBUS_GERROR_SPAWN_CHILD_EXITED;
			} else if (strcmp (_tmp3_, "Spawn.ChildSignaled") == 0) {
				_ecode = DBUS_GERROR_SPAWN_CHILD_SIGNALED;
			} else if (strcmp (_tmp3_, "Spawn.Failed") == 0) {
				_ecode = DBUS_GERROR_SPAWN_FAILED;
			} else if (strcmp (_tmp3_, "UnixProcessIdUnknown") == 0) {
				_ecode = DBUS_GERROR_UNIX_PROCESS_ID_UNKNOWN;
			} else if (strcmp (_tmp3_, "InvalidSignature") == 0) {
				_ecode = DBUS_GERROR_INVALID_SIGNATURE;
			} else if (strcmp (_tmp3_, "InvalidFileContent") == 0) {
				_ecode = DBUS_GERROR_INVALID_FILE_CONTENT;
			} else if (strcmp (_tmp3_, "SELinuxSecurityContextUnknown") == 0) {
				_ecode = DBUS_GERROR_SELINUX_SECURITY_CONTEXT_UNKNOWN;
			} else if (strcmp (_tmp3_, "RemoteException") == 0) {
				_ecode = DBUS_GERROR_REMOTE_EXCEPTION;
			}
		}
		g_set_error (error, _edomain, _ecode, "%s", _dbus_error.message);
		dbus_error_free (&_dbus_error);
		return NULL;
	}
	if (strcmp (dbus_message_get_signature (_reply), "as")) {
		g_set_error (error, DBUS_GERROR, DBUS_GERROR_INVALID_SIGNATURE, "Invalid signature, expected \"%s\", got \"%s\"", "as", dbus_message_get_signature (_reply));
		dbus_message_unref (_reply);
		return NULL;
	}
	dbus_message_iter_init (_reply, &_iter);
	_result_length1 = 0;
	_tmp4_ = g_new (gchar*, 5);
	_tmp4__length = 0;
	_tmp4__size = 4;
	_tmp4__length1 = 0;
	dbus_message_iter_recurse (&_iter, &_tmp5_);
	for (; dbus_message_iter_get_arg_type (&_tmp5_); _tmp4__length1++) {
		const char* _tmp6_;
		if (_tmp4__size == _tmp4__length) {
			_tmp4__size = 2 * _tmp4__size;
			_tmp4_ = g_renew (gchar*, _tmp4_, _tmp4__size + 1);
		}
		dbus_message_iter_get_basic (&_tmp5_, &_tmp6_);
		dbus_message_iter_next (&_tmp5_);
		_tmp4_[_tmp4__length++] = g_strdup (_tmp6_);
	}
	_result_length1 = _tmp4__length1;
	_tmp4_[_tmp4__length] = NULL;
	dbus_message_iter_next (&_iter);
	_result = _tmp4_;
	*result_length1 = _result_length1;
	dbus_message_unref (_reply);
	return _result;
}


static void dock_manager_dbus_proxy_awn_set_visibility_async (DockManager* self, const gchar* win_class, gboolean visible, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DBusGConnection *_connection;
	DBusMessage *_message;
	DBusPendingCall *_pending;
	DBusMessageIter _iter;
	const char* _tmp7_;
	dbus_bool_t _tmp8_;
	DockManagerDBusProxyAwnSetVisibilityData* _data_;
	_message = dbus_message_new_method_call (dbus_g_proxy_get_bus_name ((DBusGProxy*) self), dbus_g_proxy_get_path ((DBusGProxy*) self), "net.launchpad.DockManager", "AwnSetVisibility");
	dbus_message_iter_init_append (_message, &_iter);
	_tmp7_ = win_class;
	dbus_message_iter_append_basic (&_iter, DBUS_TYPE_STRING, &_tmp7_);
	_tmp8_ = visible;
	dbus_message_iter_append_basic (&_iter, DBUS_TYPE_BOOLEAN, &_tmp8_);
	g_object_get (self, "connection", &_connection, NULL);
	dbus_connection_send_with_reply (dbus_g_connection_get_connection (_connection), _message, &_pending, -1);
	dbus_g_connection_unref (_connection);
	dbus_message_unref (_message);
	_data_ = g_slice_new0 (DockManagerDBusProxyAwnSetVisibilityData);
	_data_->_callback_ = _callback_;
	_data_->_user_data_ = _user_data_;
	_data_->pending = _pending;
	dbus_pending_call_set_notify (_pending, dock_manager_dbus_proxy_awn_set_visibility_ready, _data_, NULL);
}


static void dock_manager_dbus_proxy_awn_set_visibility_ready (DBusPendingCall* pending, void* user_data) {
	DockManagerDBusProxyAwnSetVisibilityData* _data_;
	GObject * _obj_;
	GSimpleAsyncResult * _res_;
	_data_ = user_data;
	_obj_ = g_object_newv (G_TYPE_OBJECT, 0, NULL);
	_res_ = g_simple_async_result_new (_obj_, _data_->_callback_, _data_->_user_data_, _data_);
	g_simple_async_result_complete (_res_);
	g_object_unref (_obj_);
	g_object_unref (_res_);
	g_slice_free (DockManagerDBusProxyAwnSetVisibilityData, _data_);
	dbus_pending_call_unref (pending);
}


static void dock_manager_dbus_proxy_awn_set_visibility_finish (DockManager* self, GAsyncResult* _res_, GError** error) {
	DockManagerDBusProxyAwnSetVisibilityData* _data_;
	DBusError _dbus_error;
	DBusMessage *_reply;
	DBusMessageIter _iter;
	_data_ = g_simple_async_result_get_source_tag ((GSimpleAsyncResult *) _res_);
	dbus_error_init (&_dbus_error);
	_reply = dbus_pending_call_steal_reply (_data_->pending);
	dbus_set_error_from_message (&_dbus_error, _reply);
	if (dbus_error_is_set (&_dbus_error)) {
		GQuark _edomain = 0;
		gint _ecode = 0;
		if (strstr (_dbus_error.name, "org.freedesktop.DBus.Error") == _dbus_error.name) {
			const char* _tmp9_;
			_edomain = DBUS_GERROR;
			_tmp9_ = _dbus_error.name + 27;
			if (strcmp (_tmp9_, "Failed") == 0) {
				_ecode = DBUS_GERROR_FAILED;
			} else if (strcmp (_tmp9_, "NoMemory") == 0) {
				_ecode = DBUS_GERROR_NO_MEMORY;
			} else if (strcmp (_tmp9_, "ServiceUnknown") == 0) {
				_ecode = DBUS_GERROR_SERVICE_UNKNOWN;
			} else if (strcmp (_tmp9_, "NameHasNoOwner") == 0) {
				_ecode = DBUS_GERROR_NAME_HAS_NO_OWNER;
			} else if (strcmp (_tmp9_, "NoReply") == 0) {
				_ecode = DBUS_GERROR_NO_REPLY;
			} else if (strcmp (_tmp9_, "IOError") == 0) {
				_ecode = DBUS_GERROR_IO_ERROR;
			} else if (strcmp (_tmp9_, "BadAddress") == 0) {
				_ecode = DBUS_GERROR_BAD_ADDRESS;
			} else if (strcmp (_tmp9_, "NotSupported") == 0) {
				_ecode = DBUS_GERROR_NOT_SUPPORTED;
			} else if (strcmp (_tmp9_, "LimitsExceeded") == 0) {
				_ecode = DBUS_GERROR_LIMITS_EXCEEDED;
			} else if (strcmp (_tmp9_, "AccessDenied") == 0) {
				_ecode = DBUS_GERROR_ACCESS_DENIED;
			} else if (strcmp (_tmp9_, "AuthFailed") == 0) {
				_ecode = DBUS_GERROR_AUTH_FAILED;
			} else if (strcmp (_tmp9_, "NoServer") == 0) {
				_ecode = DBUS_GERROR_NO_SERVER;
			} else if (strcmp (_tmp9_, "Timeout") == 0) {
				_ecode = DBUS_GERROR_TIMEOUT;
			} else if (strcmp (_tmp9_, "NoNetwork") == 0) {
				_ecode = DBUS_GERROR_NO_NETWORK;
			} else if (strcmp (_tmp9_, "AddressInUse") == 0) {
				_ecode = DBUS_GERROR_ADDRESS_IN_USE;
			} else if (strcmp (_tmp9_, "Disconnected") == 0) {
				_ecode = DBUS_GERROR_DISCONNECTED;
			} else if (strcmp (_tmp9_, "InvalidArgs") == 0) {
				_ecode = DBUS_GERROR_INVALID_ARGS;
			} else if (strcmp (_tmp9_, "FileNotFound") == 0) {
				_ecode = DBUS_GERROR_FILE_NOT_FOUND;
			} else if (strcmp (_tmp9_, "FileExists") == 0) {
				_ecode = DBUS_GERROR_FILE_EXISTS;
			} else if (strcmp (_tmp9_, "UnknownMethod") == 0) {
				_ecode = DBUS_GERROR_UNKNOWN_METHOD;
			} else if (strcmp (_tmp9_, "TimedOut") == 0) {
				_ecode = DBUS_GERROR_TIMED_OUT;
			} else if (strcmp (_tmp9_, "MatchRuleNotFound") == 0) {
				_ecode = DBUS_GERROR_MATCH_RULE_NOT_FOUND;
			} else if (strcmp (_tmp9_, "MatchRuleInvalid") == 0) {
				_ecode = DBUS_GERROR_MATCH_RULE_INVALID;
			} else if (strcmp (_tmp9_, "Spawn.ExecFailed") == 0) {
				_ecode = DBUS_GERROR_SPAWN_EXEC_FAILED;
			} else if (strcmp (_tmp9_, "Spawn.ForkFailed") == 0) {
				_ecode = DBUS_GERROR_SPAWN_FORK_FAILED;
			} else if (strcmp (_tmp9_, "Spawn.ChildExited") == 0) {
				_ecode = DBUS_GERROR_SPAWN_CHILD_EXITED;
			} else if (strcmp (_tmp9_, "Spawn.ChildSignaled") == 0) {
				_ecode = DBUS_GERROR_SPAWN_CHILD_SIGNALED;
			} else if (strcmp (_tmp9_, "Spawn.Failed") == 0) {
				_ecode = DBUS_GERROR_SPAWN_FAILED;
			} else if (strcmp (_tmp9_, "UnixProcessIdUnknown") == 0) {
				_ecode = DBUS_GERROR_UNIX_PROCESS_ID_UNKNOWN;
			} else if (strcmp (_tmp9_, "InvalidSignature") == 0) {
				_ecode = DBUS_GERROR_INVALID_SIGNATURE;
			} else if (strcmp (_tmp9_, "InvalidFileContent") == 0) {
				_ecode = DBUS_GERROR_INVALID_FILE_CONTENT;
			} else if (strcmp (_tmp9_, "SELinuxSecurityContextUnknown") == 0) {
				_ecode = DBUS_GERROR_SELINUX_SECURITY_CONTEXT_UNKNOWN;
			} else if (strcmp (_tmp9_, "RemoteException") == 0) {
				_ecode = DBUS_GERROR_REMOTE_EXCEPTION;
			}
		}
		g_set_error (error, _edomain, _ecode, "%s", _dbus_error.message);
		dbus_error_free (&_dbus_error);
		return;
	}
	if (strcmp (dbus_message_get_signature (_reply), "")) {
		g_set_error (error, DBUS_GERROR, DBUS_GERROR_INVALID_SIGNATURE, "Invalid signature, expected \"%s\", got \"%s\"", "", dbus_message_get_signature (_reply));
		dbus_message_unref (_reply);
		return;
	}
	dbus_message_iter_init (_reply, &_iter);
	dbus_message_unref (_reply);
}


static void dock_manager_dbus_proxy_dock_manager__interface_init (DockManagerIface* iface) {
	iface->get_capabilities = dock_manager_dbus_proxy_get_capabilities_async;
	iface->get_capabilities_finish = dock_manager_dbus_proxy_get_capabilities_finish;
	iface->awn_set_visibility = dock_manager_dbus_proxy_awn_set_visibility_async;
	iface->awn_set_visibility_finish = dock_manager_dbus_proxy_awn_set_visibility_finish;
}


static void _vala_dock_manager_dbus_proxy_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
}


static void _vala_dock_manager_dbus_proxy_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
}


PrefsApplet* prefs_applet_construct (GType object_type, const gchar* canonical_name, const gchar* uid, gint panel_id) {
	PrefsApplet * self = NULL;
	g_return_val_if_fail (canonical_name != NULL, NULL);
	g_return_val_if_fail (uid != NULL, NULL);
	self = (PrefsApplet*) g_object_new (object_type, "canonical-name", canonical_name, "uid", uid, "panel-id", panel_id, NULL);
	return self;
}


PrefsApplet* prefs_applet_new (const gchar* canonical_name, const gchar* uid, gint panel_id) {
	return prefs_applet_construct (TYPE_PREFS_APPLET, canonical_name, uid, panel_id);
}


static void _prefs_applet_on_clicked_awn_icon_clicked (AwnIcon* _sender, gpointer self) {
	prefs_applet_on_clicked (self);
}


static void _prefs_applet_on_context_menu_popup_awn_icon_context_menu_popup (AwnIcon* _sender, GdkEventButton* event, gpointer self) {
	prefs_applet_on_context_menu_popup (self, event);
}


static void _prefs_applet_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender, GdkDragContext* context, gpointer self) {
	prefs_applet_on_drag_begin (self, context);
}


static void _prefs_applet_on_drag_end_gtk_widget_drag_end (GtkWidget* _sender, GdkDragContext* context, gpointer self) {
	prefs_applet_on_drag_end (self, context);
}


static gboolean _prefs_applet_on_drag_failed_gtk_widget_drag_failed (GtkWidget* _sender, GdkDragContext* p0, GtkDragResult p1, gpointer self) {
	gboolean result;
	result = prefs_applet_on_drag_failed (self, p0, p1);
	return result;
}


static void _prefs_applet_taskmanager_appeared_awn_dbus_watcher_name_appeared (AwnDBusWatcher* _sender, const gchar* name, gpointer self) {
	prefs_applet_taskmanager_appeared (self, name);
}


static void _lambda10_ (AwnApplet* w, PrefsApplet* self) {
	g_return_if_fail (w != NULL);
	prefs_applet_update_taskmanager (self, TRUE, NULL, NULL);
}


static void __lambda10__awn_applet_applet_deleted (AwnApplet* _sender, gpointer self) {
	_lambda10_ (_sender, self);
}


static void prefs_applet_real_constructed (GObject* base) {
	PrefsApplet * self;
	gint _tmp0_;
	DesktopAgnosticConfigClient* _tmp1_ = NULL;
	DesktopAgnosticConfigClient* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_ = NULL;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar** _tmp13_ = NULL;
	gchar** _tmp14_;
	gint _tmp14__length1;
	AwnIcon* _tmp15_ = NULL;
	AwnIcon* icon;
	GdkPixbuf* _tmp16_ = NULL;
	GdkPixbuf* pixbuf;
	AwnDBusWatcher* _tmp17_ = NULL;
	AwnDBusWatcher* watcher;
	GError * _inner_error_ = NULL;
	self = (PrefsApplet*) base;
	G_OBJECT_CLASS (prefs_applet_parent_class)->constructed ((GObject*) AWN_APPLET_SIMPLE (self));
	g_object_get ((AwnApplet*) self, "panel-id", &_tmp0_, NULL);
	_tmp1_ = awn_config_get_default (_tmp0_, &_inner_error_);
	_tmp2_ = _tmp1_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	self->priv->panel_client = _tmp2_;
	_tmp3_ = g_strdup ("main-icon");
	_tmp4_ = g_strdup ("dir");
	_tmp5_ = g_strdup ("prefs");
	_tmp6_ = g_strdup ("about");
	_tmp7_ = g_new0 (gchar*, 4 + 1);
	_tmp7_[0] = _tmp3_;
	_tmp7_[1] = _tmp4_;
	_tmp7_[2] = _tmp5_;
	_tmp7_[3] = _tmp6_;
	_tmp8_ = _tmp7_;
	_tmp8__length1 = 4;
	_tmp9_ = g_strdup ("awn-settings");
	_tmp10_ = g_strdup ("gtk-directory");
	_tmp11_ = g_strdup ("gtk-preferences");
	_tmp12_ = g_strdup ("gtk-about");
	_tmp13_ = g_new0 (gchar*, 4 + 1);
	_tmp13_[0] = _tmp9_;
	_tmp13_[1] = _tmp10_;
	_tmp13_[2] = _tmp11_;
	_tmp13_[3] = _tmp12_;
	_tmp14_ = _tmp13_;
	_tmp14__length1 = 4;
	awn_applet_simple_set_icon_info ((AwnAppletSimple*) self, _tmp8_, _tmp14_);
	_tmp14_ = (_vala_array_free (_tmp14_, _tmp14__length1, (GDestroyNotify) g_free), NULL);
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
	awn_applet_simple_set_icon_state ((AwnAppletSimple*) self, "main-icon");
	_tmp15_ = awn_applet_simple_get_icon ((AwnAppletSimple*) self);
	icon = _tmp15_;
	g_signal_connect_object (icon, "clicked", (GCallback) _prefs_applet_on_clicked_awn_icon_clicked, self, 0);
	g_signal_connect_object (icon, "context-menu-popup", (GCallback) _prefs_applet_on_context_menu_popup_awn_icon_context_menu_popup, self, 0);
	g_signal_connect_object ((GtkWidget*) icon, "drag-begin", (GCallback) _prefs_applet_on_drag_begin_gtk_widget_drag_begin, self, 0);
	g_signal_connect_object ((GtkWidget*) icon, "drag-end", (GCallback) _prefs_applet_on_drag_end_gtk_widget_drag_end, self, 0);
	g_signal_connect_object ((GtkWidget*) icon, "drag-failed", (GCallback) _prefs_applet_on_drag_failed_gtk_widget_drag_failed, self, 0);
	gtk_drag_source_set ((GtkWidget*) icon, GDK_BUTTON1_MASK, PREFS_APPLET_targets, G_N_ELEMENTS (PREFS_APPLET_targets), GDK_ACTION_LINK);
	_tmp16_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, TRUE, 8, 1, 1);
	pixbuf = _tmp16_;
	gdk_pixbuf_fill (pixbuf, (guint32) 0);
	gtk_drag_source_set_icon_pixbuf ((GtkWidget*) icon, pixbuf);
	awn_applet_simple_set_tooltip_text ((AwnAppletSimple*) self, "Avant Window Navigator");
	prefs_applet_initialize_menu (self);
	_tmp17_ = awn_dbus_watcher_get_default ();
	watcher = _tmp17_;
	g_signal_connect_object (watcher, "name-appeared::net.launchpad.DockManager", (GCallback) _prefs_applet_taskmanager_appeared_awn_dbus_watcher_name_appeared, self, 0);
	prefs_applet_update_taskmanager (self, FALSE, NULL, NULL);
	g_signal_connect_object ((AwnApplet*) self, "applet-deleted", (GCallback) __lambda10__awn_applet_applet_deleted, self, 0);
	_g_object_unref0 (pixbuf);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _prefs_applet_on_quit_click_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	prefs_applet_on_quit_click (self);
}


static void _lambda9_ (GtkMenuItem* w, PrefsApplet* self) {
	g_return_if_fail (w != NULL);
	prefs_applet_run_preferences (self, TRUE);
}


static void __lambda9__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	_lambda9_ (_sender, self);
}


static void prefs_applet_initialize_menu (PrefsApplet* self) {
	GtkWidget* _tmp0_ = NULL;
	GtkWidget* _tmp1_;
	GtkMenu* _tmp2_;
	GtkImageMenuItem* _tmp3_ = NULL;
	GtkImageMenuItem* quit_item;
	const gchar* _tmp4_ = NULL;
	GtkImageMenuItem* _tmp5_ = NULL;
	GtkImageMenuItem* about_item;
	GtkImage* _tmp6_ = NULL;
	GtkImage* _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = awn_applet_create_default_menu ((AwnApplet*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = _g_object_ref0 (GTK_IS_MENU (_tmp1_) ? ((GtkMenu*) _tmp1_) : NULL);
	_g_object_unref0 (self->priv->ctx_menu);
	self->priv->ctx_menu = _tmp2_;
	_tmp3_ = (GtkImageMenuItem*) gtk_image_menu_item_new_from_stock (GTK_STOCK_QUIT, NULL);
	quit_item = g_object_ref_sink (_tmp3_);
	g_signal_connect_object ((GtkMenuItem*) quit_item, "activate", (GCallback) _prefs_applet_on_quit_click_gtk_menu_item_activate, self, 0);
	gtk_widget_show ((GtkWidget*) quit_item);
	gtk_menu_shell_append ((GtkMenuShell*) self->priv->ctx_menu, (GtkWidget*) ((GtkMenuItem*) quit_item));
	_tmp4_ = _ ("About Awn");
	_tmp5_ = (GtkImageMenuItem*) gtk_image_menu_item_new_with_label (_tmp4_);
	about_item = g_object_ref_sink (_tmp5_);
	_tmp6_ = (GtkImage*) gtk_image_new_from_stock (GTK_STOCK_ABOUT, GTK_ICON_SIZE_MENU);
	_tmp7_ = g_object_ref_sink (_tmp6_);
	gtk_image_menu_item_set_image (about_item, (GtkWidget*) _tmp7_);
	_g_object_unref0 (_tmp7_);
	g_signal_connect_object ((GtkMenuItem*) about_item, "activate", (GCallback) __lambda9__gtk_menu_item_activate, self, 0);
	gtk_widget_show ((GtkWidget*) about_item);
	gtk_menu_shell_append ((GtkMenuShell*) self->priv->ctx_menu, (GtkWidget*) ((GtkMenuItem*) about_item));
	awn_utils_show_menu_images (self->priv->ctx_menu);
	_g_object_unref0 (about_item);
	_g_object_unref0 (quit_item);
}


static void prefs_applet_taskmanager_appeared (PrefsApplet* self, const gchar* name) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	prefs_applet_update_taskmanager (self, FALSE, NULL, NULL);
}


static void prefs_applet_update_taskmanager_data_free (gpointer _data) {
	PrefsAppletUpdateTaskmanagerData* data;
	data = _data;
	_g_object_unref0 (data->self);
	g_slice_free (PrefsAppletUpdateTaskmanagerData, data);
}


static void prefs_applet_update_taskmanager (PrefsApplet* self, gboolean visible, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	PrefsAppletUpdateTaskmanagerData* _data_;
	_data_ = g_slice_new0 (PrefsAppletUpdateTaskmanagerData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, prefs_applet_update_taskmanager);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, prefs_applet_update_taskmanager_data_free);
	_data_->self = _g_object_ref0 (self);
	_data_->visible = visible;
	prefs_applet_update_taskmanager_co (_data_);
}


static void prefs_applet_update_taskmanager_finish (PrefsApplet* self, GAsyncResult* _res_) {
	PrefsAppletUpdateTaskmanagerData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static void prefs_applet_update_taskmanager_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	PrefsAppletUpdateTaskmanagerData* data;
	data = _user_data_;
	data->_source_object_ = source_object;
	data->_res_ = _res_;
	prefs_applet_update_taskmanager_co (data);
}


static gboolean prefs_applet_update_taskmanager_co (PrefsAppletUpdateTaskmanagerData* data) {
	switch (data->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	data->_tmp0_ = NULL;
	data->_tmp0_ = dbus_g_bus_get (DBUS_BUS_SESSION, &data->_inner_error_);
	data->con = data->_tmp0_;
	if (data->_inner_error_ != NULL) {
		if (data->_inner_error_->domain == DBUS_GERROR) {
			goto __catch0_dbus_gerror;
		}
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, data->_inner_error_->message, g_quark_to_string (data->_inner_error_->domain), data->_inner_error_->code);
		g_clear_error (&data->_inner_error_);
		return FALSE;
	}
	data->taskman = dock_manager_dbus_proxy_new (data->con, "net.launchpad.DockManager", "/net/launchpad/DockManager");
	data->_state_ = 1;
	dock_manager_get_capabilities (data->taskman, prefs_applet_update_taskmanager_ready, data);
	return FALSE;
	_state_1:
	data->_tmp2_ = NULL;
	data->_tmp2_ = dock_manager_get_capabilities_finish (data->taskman, data->_res_, &data->_tmp1_, &data->_inner_error_);
	data->caps = data->_tmp2_;
	data->caps_length1 = data->_tmp1_;
	data->_caps_size_ = data->_tmp1_;
	if (data->_inner_error_ != NULL) {
		_g_object_unref0 (data->taskman);
		_dbus_g_connection_unref0 (data->con);
		if (data->_inner_error_->domain == DBUS_GERROR) {
			goto __catch0_dbus_gerror;
		}
		_g_object_unref0 (data->taskman);
		_dbus_g_connection_unref0 (data->con);
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, data->_inner_error_->message, g_quark_to_string (data->_inner_error_->domain), data->_inner_error_->code);
		g_clear_error (&data->_inner_error_);
		return FALSE;
	}
	data->supports_visibility_setting = FALSE;
	{
		data->cap_collection = data->caps;
		data->cap_collection_length1 = data->caps_length1;
		for (data->cap_it = 0; data->cap_it < data->caps_length1; data->cap_it = data->cap_it + 1) {
			data->_tmp3_ = g_strdup (data->cap_collection[data->cap_it]);
			data->cap = data->_tmp3_;
			{
				if (g_strcmp0 (data->cap, "x-awn-set-visibility") == 0) {
					data->supports_visibility_setting = TRUE;
				}
				_g_free0 (data->cap);
			}
		}
	}
	if (data->supports_visibility_setting) {
		dock_manager_awn_set_visibility (data->taskman, "awn-settings", data->visible, NULL, NULL);
	}
	data->caps = (_vala_array_free (data->caps, data->caps_length1, (GDestroyNotify) g_free), NULL);
	_g_object_unref0 (data->taskman);
	_dbus_g_connection_unref0 (data->con);
	goto __finally0;
	__catch0_dbus_gerror:
	{
		data->err = data->_inner_error_;
		data->_inner_error_ = NULL;
		_g_error_free0 (data->err);
	}
	__finally0:
	if (data->_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, data->_inner_error_->message, g_quark_to_string (data->_inner_error_->domain), data->_inner_error_->code);
		g_clear_error (&data->_inner_error_);
		return FALSE;
	}
	if (data->_state_ == 0) {
		g_simple_async_result_complete_in_idle (data->_async_result);
	} else {
		g_simple_async_result_complete (data->_async_result);
	}
	g_object_unref (data->_async_result);
	return FALSE;
}


static void prefs_applet_on_active_changed (PrefsApplet* self, WnckWindow* old_active) {
	AwnIcon* _tmp0_ = NULL;
	AwnIcon* icon;
	g_return_if_fail (self != NULL);
	_tmp0_ = awn_applet_simple_get_icon ((AwnAppletSimple*) self);
	icon = _tmp0_;
	{
		GList* window_collection;
		GList* window_it;
		window_collection = self->priv->windows;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window;
			window = (WnckWindow*) window_it->data;
			{
				gboolean _tmp1_;
				_tmp1_ = wnck_window_is_active (window);
				if (_tmp1_) {
					awn_icon_set_is_active (icon, TRUE);
					return;
				}
			}
		}
	}
	awn_icon_set_is_active (icon, FALSE);
}


static void prefs_applet_on_window_opened (PrefsApplet* self, WnckWindow* window) {
	WnckClassGroup* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (window != NULL);
	_tmp0_ = wnck_window_get_class_group (window);
	_tmp1_ = wnck_class_group_get_name (_tmp0_);
	if (g_strcmp0 (_tmp1_, "awn-settings") == 0) {
		self->priv->windows = g_list_append (self->priv->windows, window);
	}
	prefs_applet_update_icon (self);
}


static void prefs_applet_on_window_closed (PrefsApplet* self, WnckWindow* window) {
	GList* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (window != NULL);
	_tmp0_ = g_list_find (self->priv->windows, window);
	if (_tmp0_ != NULL) {
		self->priv->windows = g_list_remove (self->priv->windows, window);
	}
	prefs_applet_update_icon (self);
}


static void prefs_applet_update_icon (PrefsApplet* self) {
	AwnIcon* _tmp0_ = NULL;
	AwnIcon* icon;
	guint _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = awn_applet_simple_get_icon ((AwnAppletSimple*) self);
	icon = _tmp0_;
	_tmp1_ = g_list_length (self->priv->windows);
	awn_icon_set_indicator_count (icon, (gint) _tmp1_);
}


static gboolean prefs_applet_on_timer_tick (PrefsApplet* self) {
	gboolean result = FALSE;
	gint mouse_x = 0;
	gint mouse_y = 0;
	GdkScreen* screen = NULL;
	GdkRectangle rect = {0};
	AwnIcon* _tmp0_ = NULL;
	GdkDisplay* _tmp1_ = NULL;
	GdkScreen* _tmp2_ = NULL;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint monitor_num;
	gint _tmp6_;
	gint n_monitors;
	gint _tmp7_;
	gint default_mon;
	GdkRectangle _tmp8_ = {0};
	gfloat rel_x;
	gfloat rel_y;
	GtkPositionType pos = 0;
	gboolean _tmp9_ = FALSE;
	gboolean is_top;
	gboolean _tmp10_ = FALSE;
	gboolean is_bottom;
	gboolean _tmp11_ = FALSE;
	gboolean is_left;
	gboolean _tmp12_ = FALSE;
	gboolean is_right;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	gboolean on_edge;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = awn_applet_simple_get_icon ((AwnAppletSimple*) self);
	_tmp1_ = gtk_widget_get_display ((GtkWidget*) _tmp0_);
	gdk_display_get_pointer (_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, NULL);
	screen = _tmp2_;
	mouse_x = _tmp3_;
	mouse_y = _tmp4_;
	_tmp5_ = gdk_screen_get_monitor_at_point (screen, mouse_x, mouse_y);
	monitor_num = _tmp5_;
	_tmp6_ = gdk_screen_get_n_monitors (screen);
	n_monitors = _tmp6_;
	_tmp7_ = gdk_screen_get_monitor_at_point (screen, 0, 0);
	default_mon = _tmp7_;
	gdk_screen_get_monitor_geometry (screen, monitor_num, &_tmp8_);
	rect = _tmp8_;
	rel_x = (mouse_x - rect.x) / ((gfloat) rect.width);
	rel_y = (mouse_y - rect.y) / ((gfloat) rect.height);
	if (rel_y <= 0.15) {
		_tmp9_ = rel_y >= 0;
	} else {
		_tmp9_ = FALSE;
	}
	is_top = _tmp9_;
	if (rel_y >= 0.85) {
		_tmp10_ = rel_y <= 1;
	} else {
		_tmp10_ = FALSE;
	}
	is_bottom = _tmp10_;
	if (rel_x <= 0.15) {
		_tmp11_ = rel_x >= 0;
	} else {
		_tmp11_ = FALSE;
	}
	is_left = _tmp11_;
	if (rel_x >= 0.85) {
		_tmp12_ = rel_x <= 1;
	} else {
		_tmp12_ = FALSE;
	}
	is_right = _tmp12_;
	if (is_top) {
		_tmp15_ = TRUE;
	} else {
		_tmp15_ = is_bottom;
	}
	if (_tmp15_) {
		_tmp14_ = TRUE;
	} else {
		_tmp14_ = is_left;
	}
	if (_tmp14_) {
		_tmp13_ = TRUE;
	} else {
		_tmp13_ = is_right;
	}
	on_edge = _tmp13_;
	if (is_bottom) {
		pos = GTK_POS_BOTTOM;
	} else {
		if (is_top) {
			pos = GTK_POS_TOP;
		} else {
			if (is_left) {
				pos = GTK_POS_LEFT;
			} else {
				if (is_right) {
					pos = GTK_POS_RIGHT;
				} else {
					pos = GTK_POS_BOTTOM;
				}
			}
		}
	}
	desktop_agnostic_config_client_set_bool (self->priv->panel_client, "panel", "monitor_force", FALSE, &_inner_error_);
	if (_inner_error_ != NULL) {
		goto __catch1_g_error;
	}
	if (n_monitors > 1) {
		gint _tmp16_;
		gint config_mon;
		gboolean _tmp17_ = FALSE;
		_tmp16_ = desktop_agnostic_config_client_get_int (self->priv->panel_client, "panel", "monitor_num", &_inner_error_);
		config_mon = _tmp16_;
		if (_inner_error_ != NULL) {
			goto __catch1_g_error;
		}
		if (default_mon != monitor_num) {
			_tmp17_ = TRUE;
		} else {
			_tmp17_ = monitor_num != config_mon;
		}
		if (_tmp17_) {
			desktop_agnostic_config_client_set_int (self->priv->panel_client, "panel", "monitor_num", monitor_num, &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch1_g_error;
			}
		}
	}
	if (on_edge) {
		desktop_agnostic_config_client_set_int (self->priv->panel_client, "panel", "orient", (gint) pos, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_warning ("applet.vala:273: Unable to set panel properties. Error: %s", e->message);
		_g_error_free0 (e);
	}
	__finally1:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	result = TRUE;
	return result;
}


static gboolean _prefs_applet_on_timer_tick_gsource_func (gpointer self) {
	gboolean result;
	result = prefs_applet_on_timer_tick (self);
	return result;
}


static void prefs_applet_on_drag_begin (PrefsApplet* self, GdkDragContext* context) {
	const gchar* _tmp0_ = NULL;
	AwnIcon* _tmp1_ = NULL;
	AwnTooltip* _tmp2_ = NULL;
	AwnTooltip* tooltip;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	self->priv->in_drag = TRUE;
	_tmp0_ = _ ("Drag to change panel orientation");
	awn_applet_simple_set_tooltip_text ((AwnAppletSimple*) self, _tmp0_);
	_tmp1_ = awn_applet_simple_get_icon ((AwnAppletSimple*) self);
	_tmp2_ = awn_icon_get_tooltip (_tmp1_);
	tooltip = _tmp2_;
	g_object_set (tooltip, "smart-behavior", FALSE, NULL);
	g_object_set (tooltip, "toggle-on-click", FALSE, NULL);
	gtk_widget_show ((GtkWidget*) tooltip);
	if (self->priv->timer_id == 0) {
		guint _tmp3_;
		_tmp3_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 300, _prefs_applet_on_timer_tick_gsource_func, g_object_ref (self), g_object_unref);
		self->priv->timer_id = _tmp3_;
	}
	if (self->priv->autohide_cookie == 0) {
		guint _tmp4_;
		_tmp4_ = awn_applet_inhibit_autohide ((AwnApplet*) self, "awn-settings");
		self->priv->autohide_cookie = _tmp4_;
	}
}


static void prefs_applet_on_drag_end (PrefsApplet* self, GdkDragContext* context) {
	AwnIcon* _tmp0_ = NULL;
	AwnTooltip* _tmp1_ = NULL;
	AwnTooltip* tooltip;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	if (self->priv->timer_id != 0) {
		g_source_remove (self->priv->timer_id);
		self->priv->timer_id = (guint) 0;
	}
	if (self->priv->autohide_cookie != 0) {
		awn_applet_uninhibit_autohide ((AwnApplet*) self, self->priv->autohide_cookie);
		self->priv->autohide_cookie = (guint) 0;
	}
	_tmp0_ = awn_applet_simple_get_icon ((AwnAppletSimple*) self);
	_tmp1_ = awn_icon_get_tooltip (_tmp0_);
	tooltip = _tmp1_;
	gtk_widget_hide ((GtkWidget*) tooltip);
	awn_applet_simple_set_tooltip_text ((AwnAppletSimple*) self, "Avant Window Navigator");
	g_object_set (tooltip, "smart-behavior", TRUE, NULL);
	g_object_set (tooltip, "toggle-on-click", TRUE, NULL);
	self->priv->in_drag = FALSE;
}


static gboolean prefs_applet_on_drag_failed (PrefsApplet* self, GdkDragContext* context, GtkDragResult _result_) {
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (context != NULL, FALSE);
	result = TRUE;
	return result;
}


static void prefs_applet_on_clicked (PrefsApplet* self) {
	guint32 _tmp0_;
	guint32 cur_time;
	guint _tmp1_;
	g_return_if_fail (self != NULL);
	if (self->priv->in_drag) {
		return;
	}
	_tmp0_ = gtk_get_current_event_time ();
	cur_time = _tmp0_;
	_tmp1_ = g_list_length (self->priv->windows);
	if (_tmp1_ >= 1) {
		WnckWindow* window;
		gboolean _tmp2_;
		window = (WnckWindow*) self->priv->windows->data;
		_tmp2_ = wnck_window_is_active (window);
		if (_tmp2_) {
			{
				GList* w_collection;
				GList* w_it;
				w_collection = self->priv->windows;
				for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
					WnckWindow* w;
					w = (WnckWindow*) w_it->data;
					{
						wnck_window_minimize (w);
					}
				}
			}
		} else {
			wnck_window_activate (window, cur_time);
		}
	} else {
		GdkNativeWindow _tmp3_;
		GdkNativeWindow window_id;
		_tmp3_ = awn_applet_docklet_request ((AwnApplet*) self, 450, FALSE, TRUE);
		window_id = _tmp3_;
		if (((glong) window_id) != 0) {
			prefs_applet_setup_docklet (self, window_id);
		} else {
			gtk_menu_popup (self->priv->ctx_menu, NULL, NULL, NULL, NULL, (guint) 0, cur_time);
		}
	}
}


void prefs_applet_setup_label_for_docklet (AwnLabel* label, AwnApplet* docklet) {
	GtkPositionType _tmp0_;
	GtkPositionType pos_type;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (label != NULL);
	g_return_if_fail (docklet != NULL);
	_tmp0_ = awn_applet_get_pos_type (docklet);
	pos_type = _tmp0_;
	if (pos_type == GTK_POS_TOP) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = pos_type == GTK_POS_BOTTOM;
	}
	if (_tmp1_) {
		gint _tmp2_;
		_tmp2_ = awn_applet_get_size (docklet);
		gtk_widget_set_size_request ((GtkWidget*) label, -1, _tmp2_);
		gtk_misc_set_alignment ((GtkMisc*) label, 1.0f, 0.5f);
		gtk_label_set_angle ((GtkLabel*) label, (gdouble) 0);
	} else {
		gint _tmp3_;
		gint _tmp4_ = 0;
		_tmp3_ = awn_applet_get_size (docklet);
		gtk_widget_set_size_request ((GtkWidget*) label, _tmp3_, -1);
		gtk_misc_set_alignment ((GtkMisc*) label, 0.5f, 1.0f);
		if (pos_type == GTK_POS_LEFT) {
			_tmp4_ = 90;
		} else {
			_tmp4_ = 270;
		}
		gtk_label_set_angle ((GtkLabel*) label, (gdouble) _tmp4_);
	}
}


static AwnIcon* prefs_applet_new_unbound_icon (void) {
	AwnIcon* result = NULL;
	AwnIcon* icon = NULL;
	GObject* _tmp0_ = NULL;
	GObject* _tmp1_;
	GObject* _tmp2_;
	GObject* _tmp3_ = NULL;
	GObject* _tmp4_;
	GObject* _tmp5_ = NULL;
	GObject* _tmp6_;
	AwnIcon* _tmp7_;
	_tmp0_ = g_object_new (AWN_TYPE_ICON, "bind-effects", FALSE, NULL);
	_tmp1_ = _tmp0_;
	_tmp2_ = G_IS_INITIALLY_UNOWNED (_tmp1_) ? g_object_ref_sink (_tmp1_) : _tmp1_;
	_tmp3_ = g_object_ref_sink (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_object_ref (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = _g_object_ref0 (AWN_IS_ICON (_tmp6_) ? ((AwnIcon*) _tmp6_) : NULL);
	_g_object_unref0 (icon);
	icon = _tmp7_;
	_g_object_unref0 (_tmp4_);
	_g_object_unref0 (_tmp2_);
	result = icon;
	return result;
}


static void _lambda0_ (GtkObject* w, PrefsApplet* self) {
	g_return_if_fail (w != NULL);
	_g_object_unref0 (self->priv->docklet);
	self->priv->docklet = NULL;
	_g_list_free0 (self->priv->docklet_icons);
	self->priv->docklet_icons = NULL;
}


static void __lambda0__gtk_object_destroy (GtkObject* _sender, gpointer self) {
	_lambda0_ (_sender, self);
}


static void _lambda1_ (AwnApplet* w, gint s, PrefsApplet* self) {
	const gchar* icon_name = NULL;
	AwnIcon* _tmp0_ = NULL;
	AwnIcon* _tmp1_;
	AwnThemedIcon* loader;
	g_return_if_fail (w != NULL);
	_tmp0_ = awn_applet_simple_get_icon ((AwnAppletSimple*) self);
	_tmp1_ = _tmp0_;
	loader = AWN_IS_THEMED_ICON (_tmp1_) ? ((AwnThemedIcon*) _tmp1_) : NULL;
	{
		GList* widget_collection;
		GList* widget_it;
		widget_collection = self->priv->docklet_icons;
		for (widget_it = widget_collection; widget_it != NULL; widget_it = widget_it->next) {
			GtkWidget* widget;
			widget = (GtkWidget*) widget_it->data;
			{
				gconstpointer _tmp2_ = NULL;
				void* ptr;
				_tmp2_ = g_object_get_data ((GObject*) widget, "icon-name");
				ptr = _tmp2_;
				icon_name = (const gchar*) ptr;
				if (icon_name != NULL) {
					GtkWidget* _tmp3_;
					AwnIcon* it_icon;
					GdkPixbuf* _tmp4_ = NULL;
					GdkPixbuf* _tmp5_;
					_tmp3_ = widget;
					it_icon = AWN_IS_ICON (_tmp3_) ? ((AwnIcon*) _tmp3_) : NULL;
					_tmp4_ = awn_themed_icon_get_icon_at_size (loader, s, icon_name);
					_tmp5_ = _tmp4_;
					awn_icon_set_from_pixbuf (it_icon, _tmp5_);
					_g_object_unref0 (_tmp5_);
				} else {
					GtkWidget* _tmp6_;
					_tmp6_ = widget;
					prefs_applet_setup_label_for_docklet (AWN_IS_LABEL (_tmp6_) ? ((AwnLabel*) _tmp6_) : NULL, w);
				}
			}
		}
	}
}


static void __lambda1__awn_applet_size_changed (AwnApplet* _sender, gint size, gpointer self) {
	_lambda1_ (_sender, size, self);
}


static void _lambda2_ (AwnApplet* w, GtkPositionType p, PrefsApplet* self) {
	GtkWidget* _tmp0_ = NULL;
	GtkWidget* _tmp1_;
	AwnBox* box;
	g_return_if_fail (w != NULL);
	_tmp0_ = gtk_bin_get_child ((GtkBin*) w);
	_tmp1_ = _tmp0_;
	box = AWN_IS_BOX (_tmp1_) ? ((AwnBox*) _tmp1_) : NULL;
	awn_box_set_orientation_from_pos_type (box, p);
	{
		GList* widget_collection;
		GList* widget_it;
		widget_collection = self->priv->docklet_icons;
		for (widget_it = widget_collection; widget_it != NULL; widget_it = widget_it->next) {
			GtkWidget* widget;
			widget = (GtkWidget*) widget_it->data;
			{
				GType _tmp2_;
				_tmp2_ = G_TYPE_FROM_INSTANCE ((GObject*) widget);
				if (_tmp2_ == AWN_TYPE_LABEL) {
					GtkWidget* _tmp3_;
					_tmp3_ = widget;
					prefs_applet_setup_label_for_docklet (AWN_IS_LABEL (_tmp3_) ? ((AwnLabel*) _tmp3_) : NULL, w);
				}
			}
		}
	}
}


static void __lambda2__awn_applet_position_changed (AwnApplet* _sender, GtkPositionType position, gpointer self) {
	_lambda2_ (_sender, position, self);
}


static void _lambda3_ (AwnIcon* w, PrefsApplet* self) {
	g_return_if_fail (w != NULL);
	gtk_object_destroy ((GtkObject*) self->priv->docklet);
}


static void __lambda3__awn_icon_clicked (AwnIcon* _sender, gpointer self) {
	_lambda3_ (_sender, self);
}


static void _lambda4_ (AwnIcon* w, PrefsApplet* self) {
	g_return_if_fail (w != NULL);
	prefs_applet_change_icon_size (self, 32);
}


static void __lambda4__awn_icon_clicked (AwnIcon* _sender, gpointer self) {
	_lambda4_ (_sender, self);
}


static void _lambda5_ (AwnIcon* w, PrefsApplet* self) {
	g_return_if_fail (w != NULL);
	prefs_applet_change_icon_size (self, 40);
}


static void __lambda5__awn_icon_clicked (AwnIcon* _sender, gpointer self) {
	_lambda5_ (_sender, self);
}


static void _lambda6_ (AwnIcon* w, PrefsApplet* self) {
	g_return_if_fail (w != NULL);
	prefs_applet_change_icon_size (self, 48);
}


static void __lambda6__awn_icon_clicked (AwnIcon* _sender, gpointer self) {
	_lambda6_ (_sender, self);
}


static void _lambda7_ (AwnIcon* w, PrefsApplet* self) {
	g_return_if_fail (w != NULL);
	prefs_applet_run_preferences (self, FALSE);
	gtk_object_destroy ((GtkObject*) self->priv->docklet);
}


static void __lambda7__awn_icon_clicked (AwnIcon* _sender, gpointer self) {
	_lambda7_ (_sender, self);
}


static void _lambda8_ (AwnIcon* w, PrefsApplet* self) {
	g_return_if_fail (w != NULL);
	prefs_applet_run_preferences (self, TRUE);
	gtk_object_destroy ((GtkObject*) self->priv->docklet);
}


static void __lambda8__awn_icon_clicked (AwnIcon* _sender, gpointer self) {
	_lambda8_ (_sender, self);
}


void prefs_applet_setup_docklet (PrefsApplet* self, GdkNativeWindow window_id) {
	AwnIcon* icon = NULL;
	AwnLabel* label = NULL;
	AwnAlignment* align = NULL;
	gint _tmp0_;
	gint icon_size;
	gint _tmp1_;
	AwnApplet* _tmp2_ = NULL;
	AwnBox* _tmp3_ = NULL;
	AwnBox* main_box;
	GtkPositionType _tmp4_;
	AwnIcon* _tmp5_ = NULL;
	AwnIcon* _tmp6_;
	AwnThemedIcon* icon_loader;
	AwnIconBox* _tmp7_ = NULL;
	AwnIconBox* box;
	AwnIcon* _tmp8_ = NULL;
	GdkPixbuf* _tmp9_ = NULL;
	GdkPixbuf* _tmp10_;
	const gchar* _tmp11_ = NULL;
	GdkPixbuf* _tmp12_ = NULL;
	GdkPixbuf* pixbuf;
	AwnAlignment* _tmp13_ = NULL;
	AwnLabel* _tmp14_ = NULL;
	const gchar* _tmp15_ = NULL;
	AwnIconBox* _tmp16_ = NULL;
	AwnIcon* _tmp17_ = NULL;
	GdkPixbuf* _tmp18_ = NULL;
	GdkPixbuf* _tmp19_;
	AwnIcon* _tmp20_ = NULL;
	GdkPixbuf* _tmp21_ = NULL;
	GdkPixbuf* _tmp22_;
	AwnIcon* _tmp23_ = NULL;
	GdkPixbuf* _tmp24_ = NULL;
	GdkPixbuf* _tmp25_;
	AwnLabel* _tmp26_ = NULL;
	AwnIconBox* _tmp27_ = NULL;
	AwnIcon* _tmp28_ = NULL;
	GdkPixbuf* _tmp29_ = NULL;
	GdkPixbuf* _tmp30_;
	const gchar* _tmp31_ = NULL;
	AwnIcon* _tmp32_ = NULL;
	GdkPixbuf* _tmp33_ = NULL;
	GdkPixbuf* _tmp34_;
	const gchar* _tmp35_ = NULL;
	AwnApplet* _tmp36_;
	g_return_if_fail (self != NULL);
	_tmp0_ = awn_applet_get_size ((AwnApplet*) self);
	icon_size = _tmp0_;
	_g_list_free0 (self->priv->docklet_icons);
	self->priv->docklet_icons = NULL;
	g_object_get ((AwnApplet*) self, "panel-id", &_tmp1_, NULL);
	_tmp2_ = awn_applet_new ("quick-prefs", "docklet", _tmp1_);
	_g_object_unref0 (self->priv->docklet);
	self->priv->docklet = g_object_ref_sink (_tmp2_);
	g_object_set (self->priv->docklet, "quit-on-delete", FALSE, NULL);
	awn_applet_set_behavior ((AwnApplet*) self, AWN_APPLET_DOCKLET_HANDLES_POSITION_CHANGE);
	g_signal_connect_object ((GtkObject*) self->priv->docklet, "destroy", (GCallback) __lambda0__gtk_object_destroy, self, 0);
	g_signal_connect_object (self->priv->docklet, "size-changed", (GCallback) __lambda1__awn_applet_size_changed, self, 0);
	g_signal_connect_object (self->priv->docklet, "position-changed", (GCallback) __lambda2__awn_applet_position_changed, self, 0);
	_tmp3_ = (AwnBox*) awn_box_new (GTK_ORIENTATION_HORIZONTAL);
	main_box = g_object_ref_sink (_tmp3_);
	_tmp4_ = awn_applet_get_pos_type (self->priv->docklet);
	awn_box_set_orientation_from_pos_type (main_box, _tmp4_);
	gtk_container_add ((GtkContainer*) self->priv->docklet, (GtkWidget*) main_box);
	_tmp5_ = awn_applet_simple_get_icon ((AwnAppletSimple*) self);
	_tmp6_ = _tmp5_;
	icon_loader = AWN_IS_THEMED_ICON (_tmp6_) ? ((AwnThemedIcon*) _tmp6_) : NULL;
	_tmp7_ = (AwnIconBox*) awn_icon_box_new_for_applet (self->priv->docklet);
	box = g_object_ref_sink (_tmp7_);
	gtk_container_add ((GtkContainer*) main_box, (GtkWidget*) box);
	_tmp8_ = prefs_applet_new_unbound_icon ();
	_g_object_unref0 (icon);
	icon = _tmp8_;
	g_object_set_data_full ((GObject*) icon, "icon-name", (void*) "main-icon", NULL);
	_tmp9_ = awn_themed_icon_get_icon_at_size (icon_loader, icon_size, "main-icon");
	_tmp10_ = _tmp9_;
	awn_icon_set_from_pixbuf (icon, _tmp10_);
	_g_object_unref0 (_tmp10_);
	_tmp11_ = _ ("Drag to change panel orientation");
	awn_icon_set_tooltip_text (icon, _tmp11_);
	g_signal_connect_object (icon, "clicked", (GCallback) __lambda3__awn_icon_clicked, self, 0);
	g_signal_connect_object ((GtkWidget*) icon, "drag-begin", (GCallback) _prefs_applet_on_drag_begin_gtk_widget_drag_begin, self, 0);
	g_signal_connect_object ((GtkWidget*) icon, "drag-end", (GCallback) _prefs_applet_on_drag_end_gtk_widget_drag_end, self, 0);
	g_signal_connect_object ((GtkWidget*) icon, "drag-failed", (GCallback) _prefs_applet_on_drag_failed_gtk_widget_drag_failed, self, 0);
	gtk_drag_source_set ((GtkWidget*) icon, GDK_BUTTON1_MASK, PREFS_APPLET_targets, G_N_ELEMENTS (PREFS_APPLET_targets), GDK_ACTION_LINK);
	_tmp12_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, TRUE, 8, 1, 1);
	pixbuf = _tmp12_;
	gdk_pixbuf_fill (pixbuf, (guint32) 0);
	gtk_drag_source_set_icon_pixbuf ((GtkWidget*) icon, pixbuf);
	self->priv->docklet_icons = g_list_append (self->priv->docklet_icons, (GtkWidget*) icon);
	gtk_container_add ((GtkContainer*) box, (GtkWidget*) icon);
	_tmp13_ = (AwnAlignment*) awn_alignment_new_for_applet (self->priv->docklet);
	_g_object_unref0 (align);
	align = g_object_ref_sink (_tmp13_);
	_tmp14_ = awn_label_new ();
	_g_object_unref0 (label);
	label = g_object_ref_sink (_tmp14_);
	_tmp15_ = _ ("Icon size:");
	gtk_label_set_text ((GtkLabel*) label, _tmp15_);
	prefs_applet_setup_label_for_docklet (label, self->priv->docklet);
	self->priv->docklet_icons = g_list_append (self->priv->docklet_icons, (GtkWidget*) label);
	gtk_container_add ((GtkContainer*) align, (GtkWidget*) label);
	gtk_box_pack_start ((GtkBox*) main_box, (GtkWidget*) align, TRUE, TRUE, (guint) 6);
	_tmp16_ = (AwnIconBox*) awn_icon_box_new_for_applet (self->priv->docklet);
	_g_object_unref0 (box);
	box = g_object_ref_sink (_tmp16_);
	gtk_box_pack_start ((GtkBox*) main_box, (GtkWidget*) box, FALSE, FALSE, (guint) 0);
	_tmp17_ = prefs_applet_new_unbound_icon ();
	_g_object_unref0 (icon);
	icon = _tmp17_;
	_tmp18_ = awn_themed_icon_get_icon_at_size (icon_loader, 32, "dir");
	_tmp19_ = _tmp18_;
	awn_icon_set_from_pixbuf (icon, _tmp19_);
	_g_object_unref0 (_tmp19_);
	g_signal_connect_object (icon, "clicked", (GCallback) __lambda4__awn_icon_clicked, self, 0);
	gtk_container_add ((GtkContainer*) box, (GtkWidget*) icon);
	_tmp20_ = prefs_applet_new_unbound_icon ();
	_g_object_unref0 (icon);
	icon = _tmp20_;
	_tmp21_ = awn_themed_icon_get_icon_at_size (icon_loader, 40, "dir");
	_tmp22_ = _tmp21_;
	awn_icon_set_from_pixbuf (icon, _tmp22_);
	_g_object_unref0 (_tmp22_);
	g_signal_connect_object (icon, "clicked", (GCallback) __lambda5__awn_icon_clicked, self, 0);
	gtk_container_add ((GtkContainer*) box, (GtkWidget*) icon);
	_tmp23_ = prefs_applet_new_unbound_icon ();
	_g_object_unref0 (icon);
	icon = _tmp23_;
	_tmp24_ = awn_themed_icon_get_icon_at_size (icon_loader, 48, "dir");
	_tmp25_ = _tmp24_;
	awn_icon_set_from_pixbuf (icon, _tmp25_);
	_g_object_unref0 (_tmp25_);
	g_signal_connect_object (icon, "clicked", (GCallback) __lambda6__awn_icon_clicked, self, 0);
	gtk_container_add ((GtkContainer*) box, (GtkWidget*) icon);
	_tmp26_ = awn_label_new ();
	_g_object_unref0 (label);
	label = g_object_ref_sink (_tmp26_);
	gtk_box_pack_start ((GtkBox*) main_box, (GtkWidget*) label, TRUE, FALSE, (guint) 0);
	_tmp27_ = (AwnIconBox*) awn_icon_box_new_for_applet (self->priv->docklet);
	_g_object_unref0 (box);
	box = g_object_ref_sink (_tmp27_);
	gtk_container_add ((GtkContainer*) main_box, (GtkWidget*) box);
	_tmp28_ = prefs_applet_new_unbound_icon ();
	_g_object_unref0 (icon);
	icon = _tmp28_;
	g_object_set_data_full ((GObject*) icon, "icon-name", (void*) "prefs", NULL);
	_tmp29_ = awn_themed_icon_get_icon_at_size (icon_loader, icon_size, "prefs");
	_tmp30_ = _tmp29_;
	awn_icon_set_from_pixbuf (icon, _tmp30_);
	_g_object_unref0 (_tmp30_);
	_tmp31_ = _ ("Dock Preferences");
	awn_icon_set_tooltip_text (icon, _tmp31_);
	g_signal_connect_object (icon, "clicked", (GCallback) __lambda7__awn_icon_clicked, self, 0);
	self->priv->docklet_icons = g_list_append (self->priv->docklet_icons, (GtkWidget*) icon);
	gtk_container_add ((GtkContainer*) box, (GtkWidget*) icon);
	_tmp32_ = prefs_applet_new_unbound_icon ();
	_g_object_unref0 (icon);
	icon = _tmp32_;
	g_object_set_data_full ((GObject*) icon, "icon-name", (void*) "about", NULL);
	_tmp33_ = awn_themed_icon_get_icon_at_size (icon_loader, icon_size, "about");
	_tmp34_ = _tmp33_;
	awn_icon_set_from_pixbuf (icon, _tmp34_);
	_g_object_unref0 (_tmp34_);
	_tmp35_ = _ ("About Awn");
	awn_icon_set_tooltip_text (icon, _tmp35_);
	g_signal_connect_object (icon, "clicked", (GCallback) __lambda8__awn_icon_clicked, self, 0);
	self->priv->docklet_icons = g_list_append (self->priv->docklet_icons, (GtkWidget*) icon);
	gtk_container_add ((GtkContainer*) box, (GtkWidget*) icon);
	_tmp36_ = self->priv->docklet;
	gtk_plug_construct (GTK_IS_PLUG (_tmp36_) ? ((GtkPlug*) _tmp36_) : NULL, window_id);
	_g_object_unref0 (pixbuf);
	_g_object_unref0 (box);
	_g_object_unref0 (main_box);
	_g_object_unref0 (align);
	_g_object_unref0 (label);
	_g_object_unref0 (icon);
}


static void prefs_applet_change_icon_size (PrefsApplet* self, gint new_size) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	desktop_agnostic_config_client_set_int (self->priv->panel_client, "panel", "size", new_size, &_inner_error_);
	if (_inner_error_ != NULL) {
		goto __catch2_g_error;
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_warning ("applet.vala:547: Unable to set panel properties. Error: %s", e->message);
		_g_error_free0 (e);
	}
	__finally2:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void prefs_applet_run_preferences (PrefsApplet* self, gboolean about_only) {
	gchar** argv = NULL;
	gint argv_length1 = 0;
	gint _argv_size_ = 0;
	GdkScreen* _tmp7_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	if (about_only) {
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar** _tmp2_ = NULL;
		_tmp0_ = g_strdup ("awn-settings");
		_tmp1_ = g_strdup ("--about");
		_tmp2_ = g_new0 (gchar*, 2 + 1);
		_tmp2_[0] = _tmp0_;
		_tmp2_[1] = _tmp1_;
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
		argv = _tmp2_;
		argv_length1 = 2;
		_argv_size_ = 2;
	} else {
		gchar* _tmp3_;
		gint _tmp4_;
		gchar* _tmp5_ = NULL;
		gchar** _tmp6_ = NULL;
		_tmp3_ = g_strdup ("awn-settings");
		g_object_get ((AwnApplet*) self, "panel-id", &_tmp4_, NULL);
		_tmp5_ = g_strdup_printf ("--panel-id=%d", _tmp4_);
		_tmp6_ = g_new0 (gchar*, 2 + 1);
		_tmp6_[0] = _tmp3_;
		_tmp6_[1] = _tmp5_;
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
		argv = _tmp6_;
		argv_length1 = 2;
		_argv_size_ = 2;
	}
	_tmp7_ = gtk_window_get_screen ((GtkWindow*) self);
	gdk_spawn_on_screen (_tmp7_, NULL, argv, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, NULL, &_inner_error_);
	if (_inner_error_ != NULL) {
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
		goto __catch3_g_error;
	}
	argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
	goto __finally3;
	__catch3_g_error:
	{
		GError * err;
		gchar* msg = NULL;
		const gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp8_ = _ ("Could not open Awn settings: %s");
		_tmp9_ = g_strdup_printf (_tmp8_, err->message);
		_g_free0 (msg);
		msg = _tmp9_;
		g_warning ("applet.vala:579: %s", msg);
		_g_free0 (msg);
		_g_error_free0 (err);
	}
	__finally3:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void _dynamic_RemovePanel0 (DBusGProxy* self, gint param1, GError** error) {
	dbus_g_proxy_call (self, "RemovePanel", error, G_TYPE_INT, param1, G_TYPE_INVALID, G_TYPE_INVALID);
	if (*error) {
		return;
	}
}


static void prefs_applet_on_quit_click (PrefsApplet* self) {
	DBusGConnection* _tmp0_ = NULL;
	DBusGConnection* con;
	DBusGProxy* awn = NULL;
	DBusGProxy* _tmp1_ = NULL;
	gint _tmp2_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = dbus_g_bus_get (DBUS_BUS_SESSION, &_inner_error_);
	con = _tmp0_;
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == DBUS_GERROR) {
			goto __catch4_dbus_gerror;
		}
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp1_ = dbus_g_proxy_new_for_name (con, "org.awnproject.Awn", "/org/awnproject/Awn", "org.awnproject.Awn.App");
	_g_object_unref0 (awn);
	awn = _tmp1_;
	g_object_get ((AwnApplet*) self, "panel-id", &_tmp2_, NULL);
	_dynamic_RemovePanel0 (awn, _tmp2_, &_inner_error_);
	if (_inner_error_ != NULL) {
		_g_object_unref0 (awn);
		_dbus_g_connection_unref0 (con);
		if (_inner_error_->domain == DBUS_GERROR) {
			goto __catch4_dbus_gerror;
		}
		goto __finally4;
	}
	_g_object_unref0 (awn);
	_dbus_g_connection_unref0 (con);
	goto __finally4;
	__catch4_dbus_gerror:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		g_error ("applet.vala:599: %s", err->message);
		_g_error_free0 (err);
	}
	__finally4:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void prefs_applet_on_context_menu_popup (PrefsApplet* self, GdkEventButton* evt) {
	AwnIcon* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = awn_applet_simple_get_icon ((AwnAppletSimple*) self);
	awn_icon_popup_gtk_menu (_tmp0_, (GtkWidget*) self->priv->ctx_menu, (*evt).button, (*evt).time);
}


static void _prefs_applet_on_window_opened_wnck_screen_window_opened (WnckScreen* _sender, WnckWindow* window, gpointer self) {
	prefs_applet_on_window_opened (self, window);
}


static void _prefs_applet_on_window_closed_wnck_screen_window_closed (WnckScreen* _sender, WnckWindow* window, gpointer self) {
	prefs_applet_on_window_closed (self, window);
}


static void _prefs_applet_on_active_changed_wnck_screen_active_window_changed (WnckScreen* _sender, WnckWindow* previous_window, gpointer self) {
	prefs_applet_on_active_changed (self, previous_window);
}


static GObject * prefs_applet_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	PrefsApplet * self;
	WnckScreen* _tmp0_ = NULL;
	WnckScreen* wnck_screen;
	parent_class = G_OBJECT_CLASS (prefs_applet_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = PREFS_APPLET (obj);
	_tmp0_ = wnck_screen_get_default ();
	wnck_screen = _tmp0_;
	wnck_set_client_type (WNCK_CLIENT_TYPE_PAGER);
	g_signal_connect_object (wnck_screen, "window-opened", (GCallback) _prefs_applet_on_window_opened_wnck_screen_window_opened, self, 0);
	g_signal_connect_object (wnck_screen, "window-closed", (GCallback) _prefs_applet_on_window_closed_wnck_screen_window_closed, self, 0);
	g_signal_connect_object (wnck_screen, "active-window-changed", (GCallback) _prefs_applet_on_active_changed_wnck_screen_active_window_changed, self, 0);
	_g_list_free0 (self->priv->windows);
	self->priv->windows = NULL;
	return obj;
}


static void prefs_applet_class_init (PrefsAppletClass * klass) {
	prefs_applet_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PrefsAppletPrivate));
	G_OBJECT_CLASS (klass)->constructed = prefs_applet_real_constructed;
	G_OBJECT_CLASS (klass)->constructor = prefs_applet_constructor;
	G_OBJECT_CLASS (klass)->finalize = prefs_applet_finalize;
}


static void prefs_applet_instance_init (PrefsApplet * self) {
	self->priv = PREFS_APPLET_GET_PRIVATE (self);
	self->priv->panel_client = NULL;
	self->priv->ctx_menu = NULL;
	self->priv->timer_id = (guint) 0;
	self->priv->in_drag = FALSE;
	self->priv->autohide_cookie = (guint) 0;
}


static void prefs_applet_finalize (GObject* obj) {
	PrefsApplet * self;
	self = PREFS_APPLET (obj);
	_g_object_unref0 (self->priv->ctx_menu);
	_g_list_free0 (self->priv->windows);
	_g_object_unref0 (self->priv->docklet);
	_g_list_free0 (self->priv->docklet_icons);
	G_OBJECT_CLASS (prefs_applet_parent_class)->finalize (obj);
}


GType prefs_applet_get_type (void) {
	static volatile gsize prefs_applet_type_id__volatile = 0;
	if (g_once_init_enter (&prefs_applet_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PrefsAppletClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) prefs_applet_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PrefsApplet), 0, (GInstanceInitFunc) prefs_applet_instance_init, NULL };
		GType prefs_applet_type_id;
		prefs_applet_type_id = g_type_register_static (AWN_TYPE_APPLET_SIMPLE, "PrefsApplet", &g_define_type_info, 0);
		g_once_init_leave (&prefs_applet_type_id__volatile, prefs_applet_type_id);
	}
	return prefs_applet_type_id__volatile;
}


AwnApplet* awn_applet_factory_initp (const gchar* canonical_name, const gchar* uid, gint panel_id) {
	AwnApplet* result = NULL;
	PrefsApplet* _tmp0_ = NULL;
	AwnApplet* applet;
	WnckScreen* _tmp1_ = NULL;
	g_return_val_if_fail (canonical_name != NULL, NULL);
	g_return_val_if_fail (uid != NULL, NULL);
	textdomain (GETTEXT_PACKAGE);
	_tmp0_ = prefs_applet_new (canonical_name, uid, panel_id);
	applet = (AwnApplet*) g_object_ref_sink (_tmp0_);
	_tmp1_ = wnck_screen_get_default ();
	wnck_screen_force_update (_tmp1_);
	result = applet;
	return result;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



