/* simple-launcher.c generated by valac 0.12.0, the Vala compiler
 * generated from simple-launcher.vala, do not modify */

/*
 * Copyright (C) 2010 Michal Hruby <michal.mhr@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 * Author : Michal Hruby <michal.mhr@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <libawn/libawn.h>
#include <gtk/gtk.h>
#include <libdesktop-agnostic/config.h>
#include <stdlib.h>
#include <string.h>
#include <config.h>
#include <gdk/gdk.h>
#include <libdesktop-agnostic/vfs.h>
#include <libdesktop-agnostic/fdo.h>
#include <libdesktop-agnostic/ui.h>


#define TYPE_SIMPLE_LAUNCHER (simple_launcher_get_type ())
#define SIMPLE_LAUNCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SIMPLE_LAUNCHER, SimpleLauncher))
#define SIMPLE_LAUNCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SIMPLE_LAUNCHER, SimpleLauncherClass))
#define IS_SIMPLE_LAUNCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SIMPLE_LAUNCHER))
#define IS_SIMPLE_LAUNCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SIMPLE_LAUNCHER))
#define SIMPLE_LAUNCHER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SIMPLE_LAUNCHER, SimpleLauncherClass))

typedef struct _SimpleLauncher SimpleLauncher;
typedef struct _SimpleLauncherClass SimpleLauncherClass;
typedef struct _SimpleLauncherPrivate SimpleLauncherPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
#define _g_value_array_free0(var) ((var == NULL) ? NULL : (var = (g_value_array_free (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define _gdk_event_free0(var) ((var == NULL) ? NULL : (var = (gdk_event_free (var), NULL)))
#define __g_slist_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_slist_free__g_object_unref0_ (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _SimpleLauncher {
	AwnApplet parent_instance;
	SimpleLauncherPrivate * priv;
};

struct _SimpleLauncherClass {
	AwnAppletClass parent_class;
};

struct _SimpleLauncherPrivate {
	AwnIconBox* icon_box;
	AwnThemedIcon* add_icon;
	GtkMenu* menu;
	GtkMenu* add_icon_menu;
	GtkMenuItem* remove_menu_item;
	GtkMenuItem* edit_menu_item;
	DesktopAgnosticConfigClient* client;
	gchar* config_dir;
	GPtrArray* launchers;
	guint timer_id;
	GValueArray* _launcher_list;
};


static gpointer simple_launcher_parent_class = NULL;

GType simple_launcher_get_type (void) G_GNUC_CONST;
#define SIMPLE_LAUNCHER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SIMPLE_LAUNCHER, SimpleLauncherPrivate))
enum  {
	SIMPLE_LAUNCHER_DUMMY_PROPERTY,
	SIMPLE_LAUNCHER_LAUNCHER_LIST
};
#define SIMPLE_LAUNCHER_DESKTOP_ENTRY "desktop-entry-object"
SimpleLauncher* simple_launcher_new (const gchar* canonical_name, const gchar* uid, gint panel_id);
SimpleLauncher* simple_launcher_construct (GType object_type, const gchar* canonical_name, const gchar* uid, gint panel_id);
static void simple_launcher_init_widgets (SimpleLauncher* self);
static void simple_launcher_launchers_changed (SimpleLauncher* self);
static void _simple_launcher_launchers_changed_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void simple_launcher_create_new_launcher (SimpleLauncher* self);
static void _simple_launcher_create_new_launcher_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void simple_launcher_edit_clicked (SimpleLauncher* self);
static void _simple_launcher_edit_clicked_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void simple_launcher_remove_clicked (SimpleLauncher* self);
static void _simple_launcher_remove_clicked_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void simple_launcher_add_folders (SimpleLauncher* self);
static void _simple_launcher_add_folders_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void simple_launcher_uri_received (SimpleLauncher* self, GdkDragContext* context, gint x, gint y, GtkSelectionData* data, guint info, guint time_);
static void _simple_launcher_uri_received_gtk_widget_drag_data_received (GtkWidget* _sender, GdkDragContext* context, gint x, gint y, GtkSelectionData* selection_data, guint info, guint time_, gpointer self);
static gboolean _lambda1_ (SimpleLauncher* self);
static gboolean __lambda1__gtk_widget_drag_motion (GtkWidget* _sender, GdkDragContext* context, gint x, gint y, guint time_, gpointer self);
static void simple_launcher_on_add_icon_clicked (SimpleLauncher* self);
static void _simple_launcher_on_add_icon_clicked_awn_icon_clicked (AwnIcon* _sender, gpointer self);
static void _simple_launcher_on_add_icon_clicked_awn_icon_context_menu_popup (AwnIcon* _sender, GdkEventButton* event, gpointer self);
static void simple_launcher_on_size_changed (SimpleLauncher* self);
static void _simple_launcher_on_size_changed_awn_applet_size_changed (AwnApplet* _sender, gint size, gpointer self);
static gboolean _vala_string_array_contains (gchar** stack, int stack_length, gchar* needle);
static void _vala_array_add1 (gchar*** array, int* length, int* size, gchar* value);
static void simple_launcher_process_uri (SimpleLauncher* self, DesktopAgnosticVFSFile* file);
static void _g_object_unref0_ (gpointer var);
static void _g_slist_free__g_object_unref0_ (GSList* self);
static gchar* simple_launcher_pick_icon_name (SimpleLauncher* self, gchar** icon_names, int icon_names_length1);
static DesktopAgnosticVFSFile* simple_launcher_get_new_desktop_file (SimpleLauncher* self);
static AwnThemedIcon* simple_launcher_create_launcher (SimpleLauncher* self, const gchar* path);
static void _vala_array_add2 (gint** array, int* length, int* size, gint value);
static void simple_launcher_remove_launcher (SimpleLauncher* self, AwnThemedIcon* launcher, gboolean delete_desktop_file);
static void simple_launcher_on_launcher_clicked (SimpleLauncher* self, AwnIcon* launcher);
static void _simple_launcher_on_launcher_clicked_awn_icon_clicked (AwnIcon* _sender, gpointer self);
static void simple_launcher_on_launcher_ctx_menu (SimpleLauncher* self, AwnIcon* launcher, GdkEventButton* event);
static void _simple_launcher_on_launcher_ctx_menu_awn_icon_context_menu_popup (AwnIcon* _sender, GdkEventButton* event, gpointer self);
static gboolean simple_launcher_on_launcher_drag_motion (SimpleLauncher* self);
static gboolean _simple_launcher_on_launcher_drag_motion_gtk_widget_drag_motion (GtkWidget* _sender, GdkDragContext* context, gint x, gint y, guint time_, gpointer self);
static gboolean _lambda0_ (SimpleLauncher* self);
static gboolean __lambda0__gsource_func (gpointer self);
GValueArray* simple_launcher_get_launcher_list (SimpleLauncher* self);
void simple_launcher_set_launcher_list (SimpleLauncher* self, GValueArray* value);
static GObject * simple_launcher_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void simple_launcher_finalize (GObject* obj);
static void _vala_simple_launcher_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_simple_launcher_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
AwnApplet* awn_applet_factory_initp (const gchar* canonical_name, const gchar* uid, gint panel_id);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const GtkTargetEntry SIMPLE_LAUNCHER_targets[2] = {{"text/uri-list", (guint) 0, (guint) 0}, {"text/plain", (guint) 0, (guint) 0}};

static void _simple_launcher_launchers_changed_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	simple_launcher_launchers_changed (self);
}


SimpleLauncher* simple_launcher_construct (GType object_type, const gchar* canonical_name, const gchar* uid, gint panel_id) {
	SimpleLauncher * self = NULL;
	g_return_val_if_fail (canonical_name != NULL, NULL);
	g_return_val_if_fail (uid != NULL, NULL);
	self = (SimpleLauncher*) g_object_new (object_type, "canonical-name", canonical_name, "uid", uid, "panel-id", panel_id, NULL);
	simple_launcher_init_widgets (self);
	g_signal_connect_object ((GObject*) self, "notify::launcher-list", (GCallback) _simple_launcher_launchers_changed_g_object_notify, self, 0);
	simple_launcher_launchers_changed (self);
	return self;
}


SimpleLauncher* simple_launcher_new (const gchar* canonical_name, const gchar* uid, gint panel_id) {
	return simple_launcher_construct (TYPE_SIMPLE_LAUNCHER, canonical_name, uid, panel_id);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _simple_launcher_create_new_launcher_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	simple_launcher_create_new_launcher (self);
}


static void _simple_launcher_edit_clicked_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	simple_launcher_edit_clicked (self);
}


static void _simple_launcher_remove_clicked_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	simple_launcher_remove_clicked (self);
}


static void _simple_launcher_add_folders_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	simple_launcher_add_folders (self);
}


static void _simple_launcher_uri_received_gtk_widget_drag_data_received (GtkWidget* _sender, GdkDragContext* context, gint x, gint y, GtkSelectionData* selection_data, guint info, guint time_, gpointer self) {
	simple_launcher_uri_received (self, context, x, y, selection_data, info, time_);
}


static gboolean _lambda1_ (SimpleLauncher* self) {
	gboolean result = FALSE;
	AwnEffects* _tmp0_ = NULL;
	_tmp0_ = awn_overlayable_get_effects ((AwnOverlayable*) self->priv->add_icon);
	awn_effects_start_ex (_tmp0_, AWN_EFFECT_LAUNCHING, 1, FALSE, FALSE);
	result = FALSE;
	return result;
}


static gboolean __lambda1__gtk_widget_drag_motion (GtkWidget* _sender, GdkDragContext* context, gint x, gint y, guint time_, gpointer self) {
	gboolean result;
	result = _lambda1_ (self);
	return result;
}


static void _simple_launcher_on_add_icon_clicked_awn_icon_clicked (AwnIcon* _sender, gpointer self) {
	simple_launcher_on_add_icon_clicked (self);
}


static void _simple_launcher_on_add_icon_clicked_awn_icon_context_menu_popup (AwnIcon* _sender, GdkEventButton* event, gpointer self) {
	simple_launcher_on_add_icon_clicked (self);
}


static void _simple_launcher_on_size_changed_awn_applet_size_changed (AwnApplet* _sender, gint size, gpointer self) {
	simple_launcher_on_size_changed (self);
}


static void simple_launcher_init_widgets (SimpleLauncher* self) {
	GtkWidget* _tmp0_ = NULL;
	GtkWidget* _tmp1_;
	GtkMenuItem* _tmp2_;
	GtkMenuItem* about_item1;
	GtkWidget* _tmp3_ = NULL;
	GtkWidget* _tmp4_;
	GtkMenuItem* _tmp5_;
	GtkMenuItem* about_item2;
	GtkWidget* _tmp6_ = NULL;
	GtkWidget* _tmp7_;
	GtkMenu* _tmp8_;
	GtkMenuItem* _tmp9_ = NULL;
	GtkMenuItem* add_launcher_item1;
	GtkSeparatorMenuItem* _tmp10_ = NULL;
	GtkSeparatorMenuItem* _tmp11_;
	GtkMenuItem* _tmp12_ = NULL;
	GtkMenuItem* _tmp13_ = NULL;
	GtkSeparatorMenuItem* _tmp14_ = NULL;
	GtkSeparatorMenuItem* _tmp15_;
	GtkWidget* _tmp16_ = NULL;
	GtkWidget* _tmp17_;
	GtkMenu* _tmp18_;
	GtkMenuItem* _tmp19_ = NULL;
	GtkMenuItem* add_launcher_item2;
	GtkMenuItem* _tmp20_ = NULL;
	GtkMenuItem* add_folders_item;
	GtkSeparatorMenuItem* _tmp21_ = NULL;
	GtkSeparatorMenuItem* _tmp22_;
	AwnIconBox* _tmp23_ = NULL;
	AwnThemedIcon* _tmp24_ = NULL;
	gint _tmp25_;
	AwnThemedIcon* _tmp26_;
	const gchar* _tmp27_ = NULL;
	const gchar* _tmp28_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = awn_applet_create_about_item_simple ((AwnApplet*) self, "Copyright © 2010 Michal Hruby", AWN_APPLET_LICENSE_GPLV2, VERSION);
	_tmp1_ = _tmp0_;
	_tmp2_ = _g_object_ref0 (GTK_IS_MENU_ITEM (_tmp1_) ? ((GtkMenuItem*) _tmp1_) : NULL);
	about_item1 = _tmp2_;
	_tmp3_ = awn_applet_create_about_item_simple ((AwnApplet*) self, "Copyright © 2010 Michal Hruby", AWN_APPLET_LICENSE_GPLV2, VERSION);
	_tmp4_ = _tmp3_;
	_tmp5_ = _g_object_ref0 (GTK_IS_MENU_ITEM (_tmp4_) ? ((GtkMenuItem*) _tmp4_) : NULL);
	about_item2 = _tmp5_;
	_tmp6_ = awn_applet_create_default_menu ((AwnApplet*) self);
	_tmp7_ = _tmp6_;
	_tmp8_ = _g_object_ref0 (GTK_IS_MENU (_tmp7_) ? ((GtkMenu*) _tmp7_) : NULL);
	_g_object_unref0 (self->priv->menu);
	self->priv->menu = _tmp8_;
	_tmp9_ = (GtkMenuItem*) gtk_menu_item_new_with_label ("Add Launcher...");
	add_launcher_item1 = g_object_ref_sink (_tmp9_);
	g_signal_connect_object (add_launcher_item1, "activate", (GCallback) _simple_launcher_create_new_launcher_gtk_menu_item_activate, self, 0);
	gtk_menu_shell_append ((GtkMenuShell*) self->priv->menu, (GtkWidget*) add_launcher_item1);
	_tmp10_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
	_tmp11_ = g_object_ref_sink (_tmp10_);
	gtk_menu_shell_append ((GtkMenuShell*) self->priv->menu, (GtkWidget*) ((GtkMenuItem*) _tmp11_));
	_g_object_unref0 (_tmp11_);
	_tmp12_ = (GtkMenuItem*) gtk_menu_item_new_with_label ("Edit Launcher");
	_g_object_unref0 (self->priv->edit_menu_item);
	self->priv->edit_menu_item = g_object_ref_sink (_tmp12_);
	g_signal_connect_object (self->priv->edit_menu_item, "activate", (GCallback) _simple_launcher_edit_clicked_gtk_menu_item_activate, self, 0);
	gtk_menu_shell_append ((GtkMenuShell*) self->priv->menu, (GtkWidget*) self->priv->edit_menu_item);
	_tmp13_ = (GtkMenuItem*) gtk_menu_item_new_with_label ("Remove Launcher");
	_g_object_unref0 (self->priv->remove_menu_item);
	self->priv->remove_menu_item = g_object_ref_sink (_tmp13_);
	g_signal_connect_object (self->priv->remove_menu_item, "activate", (GCallback) _simple_launcher_remove_clicked_gtk_menu_item_activate, self, 0);
	gtk_menu_shell_append ((GtkMenuShell*) self->priv->menu, (GtkWidget*) self->priv->remove_menu_item);
	_tmp14_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
	_tmp15_ = g_object_ref_sink (_tmp14_);
	gtk_menu_shell_append ((GtkMenuShell*) self->priv->menu, (GtkWidget*) ((GtkMenuItem*) _tmp15_));
	_g_object_unref0 (_tmp15_);
	gtk_menu_shell_append ((GtkMenuShell*) self->priv->menu, (GtkWidget*) about_item1);
	gtk_widget_show_all ((GtkWidget*) self->priv->menu);
	_tmp16_ = awn_applet_create_default_menu ((AwnApplet*) self);
	_tmp17_ = _tmp16_;
	_tmp18_ = _g_object_ref0 (GTK_IS_MENU (_tmp17_) ? ((GtkMenu*) _tmp17_) : NULL);
	_g_object_unref0 (self->priv->add_icon_menu);
	self->priv->add_icon_menu = _tmp18_;
	_tmp19_ = (GtkMenuItem*) gtk_menu_item_new_with_label ("Add Launcher...");
	add_launcher_item2 = g_object_ref_sink (_tmp19_);
	g_signal_connect_object (add_launcher_item2, "activate", (GCallback) _simple_launcher_create_new_launcher_gtk_menu_item_activate, self, 0);
	gtk_menu_shell_append ((GtkMenuShell*) self->priv->add_icon_menu, (GtkWidget*) add_launcher_item2);
	_tmp20_ = (GtkMenuItem*) gtk_menu_item_new_with_label ("Add common folders");
	add_folders_item = g_object_ref_sink (_tmp20_);
	g_signal_connect_object (add_folders_item, "activate", (GCallback) _simple_launcher_add_folders_gtk_menu_item_activate, self, 0);
	gtk_menu_shell_append ((GtkMenuShell*) self->priv->add_icon_menu, (GtkWidget*) add_folders_item);
	_tmp21_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
	_tmp22_ = g_object_ref_sink (_tmp21_);
	gtk_menu_shell_append ((GtkMenuShell*) self->priv->add_icon_menu, (GtkWidget*) ((GtkMenuItem*) _tmp22_));
	_g_object_unref0 (_tmp22_);
	gtk_menu_shell_append ((GtkMenuShell*) self->priv->add_icon_menu, (GtkWidget*) about_item2);
	gtk_widget_show_all ((GtkWidget*) self->priv->add_icon_menu);
	_tmp23_ = (AwnIconBox*) awn_icon_box_new_for_applet ((AwnApplet*) self);
	_g_object_unref0 (self->priv->icon_box);
	self->priv->icon_box = g_object_ref_sink (_tmp23_);
	_tmp24_ = (AwnThemedIcon*) awn_themed_icon_new ();
	_g_object_unref0 (self->priv->add_icon);
	self->priv->add_icon = g_object_ref_sink (_tmp24_);
	g_object_set (self->priv->add_icon, "drag-and-drop", FALSE, NULL);
	_tmp25_ = awn_applet_get_size ((AwnApplet*) self);
	awn_themed_icon_set_size (self->priv->add_icon, _tmp25_);
	gtk_drag_dest_set ((GtkWidget*) self->priv->add_icon, GTK_DEST_DEFAULT_MOTION | GTK_DEST_DEFAULT_DROP, SIMPLE_LAUNCHER_targets, G_N_ELEMENTS (SIMPLE_LAUNCHER_targets), GDK_ACTION_COPY);
	_tmp26_ = self->priv->add_icon;
	g_signal_connect_object (GTK_IS_WIDGET (_tmp26_) ? ((GtkWidget*) _tmp26_) : NULL, "drag-data-received", (GCallback) _simple_launcher_uri_received_gtk_widget_drag_data_received, self, 0);
	g_signal_connect_object ((GtkWidget*) self->priv->add_icon, "drag-motion", (GCallback) __lambda1__gtk_widget_drag_motion, self, G_CONNECT_AFTER);
	g_signal_connect_object ((AwnIcon*) self->priv->add_icon, "clicked", (GCallback) _simple_launcher_on_add_icon_clicked_awn_icon_clicked, self, 0);
	g_signal_connect_object ((AwnIcon*) self->priv->add_icon, "context-menu-popup", (GCallback) _simple_launcher_on_add_icon_clicked_awn_icon_context_menu_popup, self, 0);
	_tmp27_ = awn_applet_get_canonical_name ((AwnApplet*) self);
	_tmp28_ = awn_applet_get_uid ((AwnApplet*) self);
	awn_themed_icon_set_info_simple (self->priv->add_icon, _tmp27_, _tmp28_, "add");
	awn_icon_set_tooltip_text ((AwnIcon*) self->priv->add_icon, "Drop launcher here");
	gtk_widget_show ((GtkWidget*) self->priv->add_icon);
	gtk_container_add ((GtkContainer*) self->priv->icon_box, (GtkWidget*) self->priv->add_icon);
	gtk_box_set_child_packing ((GtkBox*) self->priv->icon_box, (GtkWidget*) self->priv->add_icon, FALSE, FALSE, (guint) 0, GTK_PACK_END);
	gtk_widget_show ((GtkWidget*) self->priv->icon_box);
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) self->priv->icon_box);
	g_signal_connect_object ((AwnApplet*) self, "size-changed", (GCallback) _simple_launcher_on_size_changed_awn_applet_size_changed, self, 0);
	_g_object_unref0 (add_folders_item);
	_g_object_unref0 (add_launcher_item2);
	_g_object_unref0 (add_launcher_item1);
	_g_object_unref0 (about_item2);
	_g_object_unref0 (about_item1);
}


static void simple_launcher_on_size_changed (SimpleLauncher* self) {
	GList* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_container_get_children ((GtkContainer*) self->priv->icon_box);
	{
		GList* w_collection;
		GList* w_it;
		w_collection = _tmp0_;
		for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
			GtkWidget* w;
			w = (GtkWidget*) w_it->data;
			{
				GtkWidget* _tmp1_;
				AwnThemedIcon* i;
				_tmp1_ = w;
				i = AWN_IS_THEMED_ICON (_tmp1_) ? ((AwnThemedIcon*) _tmp1_) : NULL;
				if (i != NULL) {
					gint _tmp2_;
					_tmp2_ = awn_applet_get_size ((AwnApplet*) self);
					awn_themed_icon_set_size (i, _tmp2_);
				}
			}
		}
		_g_list_free0 (w_collection);
	}
}


static void simple_launcher_on_add_icon_clicked (SimpleLauncher* self) {
	GdkEvent* _tmp0_ = NULL;
	GdkEvent* e;
	guint _tmp1_ = 0U;
	gboolean _tmp2_ = FALSE;
	guint button;
	guint32 _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_get_current_event ();
	e = _tmp0_;
	if (e == NULL) {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = e->type != GDK_BUTTON_PRESS;
	}
	if (_tmp2_) {
		_tmp1_ = (guint) 0;
	} else {
		_tmp1_ = e->button.button;
	}
	button = _tmp1_;
	_tmp3_ = gtk_get_current_event_time ();
	awn_icon_popup_gtk_menu ((AwnIcon*) self->priv->add_icon, (GtkWidget*) self->priv->add_icon_menu, button, _tmp3_);
	_gdk_event_free0 (e);
}


static gboolean _vala_string_array_contains (gchar** stack, int stack_length, gchar* needle) {
	int i;
	for (i = 0; i < stack_length; i++) {
		if (g_strcmp0 (stack[i], needle) == 0) {
			return TRUE;
		}
	}
	return FALSE;
}


static void _vala_array_add1 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void simple_launcher_add_folders (SimpleLauncher* self) {
	gchar** _tmp0_ = NULL;
	gchar** directories;
	gint directories_length1;
	gint _directories_size_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_new0 (gchar*, 0 + 1);
	directories = _tmp0_;
	directories_length1 = 0;
	_directories_size_ = 0;
	g_object_freeze_notify ((GObject*) self);
	{
		GUserDirectory dir;
		dir = G_USER_DIRECTORY_DESKTOP;
		{
			gboolean _tmp1_;
			_tmp1_ = TRUE;
			while (TRUE) {
				const gchar* _tmp2_ = NULL;
				gchar* _tmp3_;
				gchar* path;
				gchar* _tmp4_;
				DesktopAgnosticVFSFile* _tmp5_ = NULL;
				DesktopAgnosticVFSFile* f;
				gboolean _tmp6_;
				if (!_tmp1_) {
					dir = dir + 1;
				}
				_tmp1_ = FALSE;
				if (!(dir <= G_USER_DIRECTORY_VIDEOS)) {
					break;
				}
				_tmp2_ = g_get_user_special_dir (dir);
				_tmp3_ = g_strdup (_tmp2_);
				path = _tmp3_;
				if (_vala_string_array_contains (directories, directories_length1, path)) {
					_g_free0 (path);
					continue;
				}
				_tmp4_ = g_strdup (path);
				_vala_array_add1 (&directories, &directories_length1, &_directories_size_, _tmp4_);
				_tmp5_ = desktop_agnostic_vfs_file_new_for_path (path, &_inner_error_);
				f = _tmp5_;
				if (_inner_error_ != NULL) {
					_g_free0 (path);
					directories = (_vala_array_free (directories, directories_length1, (GDestroyNotify) g_free), NULL);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
				_tmp6_ = desktop_agnostic_vfs_file_exists (f);
				if (_tmp6_) {
					simple_launcher_process_uri (self, f);
				}
				_g_object_unref0 (f);
				_g_free0 (path);
			}
		}
	}
	g_object_thaw_notify ((GObject*) self);
	directories = (_vala_array_free (directories, directories_length1, (GDestroyNotify) g_free), NULL);
}


static void _g_object_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static void _g_slist_free__g_object_unref0_ (GSList* self) {
	g_slist_foreach (self, (GFunc) _g_object_unref0_, NULL);
	g_slist_free (self);
}


static void simple_launcher_uri_received (SimpleLauncher* self, GdkDragContext* context, gint x, gint y, GtkSelectionData* data, guint info, guint time_) {
	gboolean _tmp0_ = FALSE;
	GSList* _tmp2_ = NULL;
	GSList* files;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	g_return_if_fail (data != NULL);
	if (data == NULL) {
		_tmp0_ = TRUE;
	} else {
		gint _tmp1_;
		_tmp1_ = gtk_selection_data_get_length (data);
		_tmp0_ = _tmp1_ == 0;
	}
	if (_tmp0_) {
		gtk_drag_finish (context, FALSE, FALSE, (guint32) time_);
		return;
	}
	_tmp2_ = desktop_agnostic_vfs_files_from_uri_list ((const gchar*) data->data, &_inner_error_);
	files = _tmp2_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	simple_launcher_process_uri (self, (DesktopAgnosticVFSFile*) files->data);
	gtk_drag_finish (context, TRUE, FALSE, (guint32) time_);
	__g_slist_free__g_object_unref0_0 (files);
}


static gchar* simple_launcher_pick_icon_name (SimpleLauncher* self, gchar** icon_names, int icon_names_length1) {
	gchar* result = NULL;
	GtkIconTheme* _tmp0_ = NULL;
	GtkIconTheme* _tmp1_;
	GtkIconTheme* it;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gtk_icon_theme_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	it = _tmp1_;
	{
		gchar** icon_collection;
		int icon_collection_length1;
		int icon_it;
		icon_collection = icon_names;
		icon_collection_length1 = icon_names_length1;
		for (icon_it = 0; icon_it < icon_names_length1; icon_it = icon_it + 1) {
			const gchar* icon;
			icon = icon_collection[icon_it];
			{
				gboolean _tmp2_;
				_tmp2_ = gtk_icon_theme_has_icon (it, icon);
				if (_tmp2_) {
					gchar* _tmp3_;
					_tmp3_ = g_strdup (icon);
					result = _tmp3_;
					_g_object_unref0 (it);
					return result;
				}
			}
		}
	}
	result = NULL;
	_g_object_unref0 (it);
	return result;
}


static void simple_launcher_process_uri (SimpleLauncher* self, DesktopAgnosticVFSFile* file) {
	gchar* _tmp0_ = NULL;
	gchar* uri;
	DesktopAgnosticVFSFile* _tmp1_ = NULL;
	DesktopAgnosticVFSFile* df;
	gchar* _tmp2_ = NULL;
	gchar* path;
	gboolean _tmp3_;
	GValue _tmp23_ = {0};
	GValue v;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	_tmp0_ = desktop_agnostic_vfs_file_get_uri (file);
	uri = _tmp0_;
	g_debug ("simple-launcher.vala:232: received %s", uri);
	_tmp1_ = simple_launcher_get_new_desktop_file (self);
	df = _tmp1_;
	_tmp2_ = desktop_agnostic_vfs_file_get_path (df);
	path = _tmp2_;
	_tmp3_ = g_str_has_suffix (uri, ".desktop");
	if (_tmp3_) {
		gboolean _tmp4_;
		_tmp4_ = desktop_agnostic_vfs_file_is_writable (file);
		if (_tmp4_) {
			DesktopAgnosticFDODesktopEntry* _tmp5_ = NULL;
			DesktopAgnosticFDODesktopEntry* de;
			_tmp5_ = desktop_agnostic_fdo_desktop_entry_new_for_file (file, &_inner_error_);
			de = _tmp5_;
			if (_inner_error_ != NULL) {
				_g_free0 (path);
				_g_object_unref0 (df);
				_g_free0 (uri);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
			desktop_agnostic_fdo_desktop_entry_save (de, df, &_inner_error_);
			if (_inner_error_ != NULL) {
				_g_object_unref0 (de);
				_g_free0 (path);
				_g_object_unref0 (df);
				_g_free0 (uri);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
			_g_object_unref0 (de);
		} else {
			gchar* _tmp6_ = NULL;
			_tmp6_ = desktop_agnostic_vfs_file_get_path (file);
			_g_free0 (path);
			path = _tmp6_;
		}
	} else {
		DesktopAgnosticFDODesktopEntry* _tmp7_ = NULL;
		DesktopAgnosticFDODesktopEntry* link_entry;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_;
		gchar* _tmp10_ = NULL;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* icon_name;
		DesktopAgnosticVFSFile* _tmp13_ = NULL;
		DesktopAgnosticVFSFile* f;
		gboolean _tmp14_;
		_tmp7_ = desktop_agnostic_fdo_desktop_entry_new (&_inner_error_);
		link_entry = _tmp7_;
		if (_inner_error_ != NULL) {
			_g_free0 (path);
			_g_object_unref0 (df);
			_g_free0 (uri);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		desktop_agnostic_fdo_desktop_entry_set_entry_type (link_entry, DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_TYPE_LINK);
		_tmp8_ = g_path_get_basename (uri);
		_tmp9_ = _tmp8_;
		_tmp10_ = g_uri_unescape_string (_tmp9_, NULL);
		_tmp11_ = _tmp10_;
		desktop_agnostic_fdo_desktop_entry_set_name (link_entry, _tmp11_);
		_g_free0 (_tmp11_);
		_g_free0 (_tmp9_);
		desktop_agnostic_fdo_desktop_entry_set_string (link_entry, "URL", uri);
		_tmp12_ = g_strdup ("image-missing");
		icon_name = _tmp12_;
		_tmp13_ = desktop_agnostic_vfs_file_new_for_uri (uri, &_inner_error_);
		f = _tmp13_;
		if (_inner_error_ != NULL) {
			goto __catch0_g_error;
		}
		_tmp14_ = desktop_agnostic_vfs_file_is_native (f);
		if (_tmp14_) {
			gint _tmp15_;
			gchar** _tmp16_ = NULL;
			gchar** _tmp17_;
			gint _tmp17__length1;
			gint __tmp17__size_;
			gchar** _tmp18_;
			gint _tmp18__length1;
			gchar* _tmp19_ = NULL;
			gchar* _tmp20_;
			gchar* i;
			_tmp16_ = desktop_agnostic_vfs_file_get_icon_names (f, &_tmp15_, &_inner_error_);
			_tmp17_ = _tmp16_;
			_tmp17__length1 = _tmp15_;
			__tmp17__size_ = _tmp15_;
			if (_inner_error_ != NULL) {
				_g_object_unref0 (f);
				goto __catch0_g_error;
			}
			_tmp18_ = _tmp17_;
			_tmp18__length1 = _tmp17__length1;
			_tmp19_ = simple_launcher_pick_icon_name (self, _tmp18_, _tmp17__length1);
			_tmp20_ = _tmp19_;
			_tmp18_ = (_vala_array_free (_tmp18_, _tmp18__length1, (GDestroyNotify) g_free), NULL);
			i = _tmp20_;
			if (i != NULL) {
				gchar* _tmp21_;
				_tmp21_ = g_strdup (i);
				_g_free0 (icon_name);
				icon_name = _tmp21_;
			}
			_g_free0 (i);
		} else {
			gchar* _tmp22_;
			_tmp22_ = g_strdup ("unknown");
			_g_free0 (icon_name);
			icon_name = _tmp22_;
		}
		_g_object_unref0 (f);
		goto __finally0;
		__catch0_g_error:
		{
			GError * err;
			err = _inner_error_;
			_inner_error_ = NULL;
			g_warning ("simple-launcher.vala:276: %s", err->message);
			_g_error_free0 (err);
		}
		__finally0:
		if (_inner_error_ != NULL) {
			_g_free0 (icon_name);
			_g_object_unref0 (link_entry);
			_g_free0 (path);
			_g_object_unref0 (df);
			_g_free0 (uri);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		desktop_agnostic_fdo_desktop_entry_set_icon (link_entry, icon_name);
		desktop_agnostic_fdo_desktop_entry_save (link_entry, df, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_free0 (icon_name);
			_g_object_unref0 (link_entry);
			_g_free0 (path);
			_g_object_unref0 (df);
			_g_free0 (uri);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_g_free0 (icon_name);
		_g_object_unref0 (link_entry);
	}
	g_value_init (&_tmp23_, G_TYPE_STRING);
	g_value_set_string (&_tmp23_, path);
	v = _tmp23_;
	g_value_array_append (self->priv->_launcher_list, &v);
	g_object_notify ((GObject*) self, "launcher-list");
	G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
	_g_free0 (path);
	_g_object_unref0 (df);
	_g_free0 (uri);
}


static DesktopAgnosticVFSFile* simple_launcher_get_new_desktop_file (SimpleLauncher* self) {
	DesktopAgnosticVFSFile* result = NULL;
	DesktopAgnosticVFSFile* f;
	gint counter;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	f = NULL;
	counter = 1;
	{
		gboolean _tmp0_;
		_tmp0_ = TRUE;
		while (TRUE) {
			gint _tmp2_;
			gchar* _tmp3_ = NULL;
			gchar* _tmp4_;
			gchar* _tmp5_ = NULL;
			gchar* _tmp6_;
			gchar* path;
			DesktopAgnosticVFSFile* _tmp7_ = NULL;
			DesktopAgnosticVFSFile* _tmp8_;
			if (!_tmp0_) {
				gboolean _tmp1_;
				_tmp1_ = desktop_agnostic_vfs_file_exists (f);
				if (!_tmp1_) {
					break;
				}
			}
			_tmp0_ = FALSE;
			_tmp2_ = counter;
			counter = _tmp2_ + 1;
			_tmp3_ = g_strdup_printf ("launcher-%d.desktop", _tmp2_);
			_tmp4_ = _tmp3_;
			_tmp5_ = g_build_filename (self->priv->config_dir, _tmp4_, NULL, NULL);
			_tmp6_ = _tmp5_;
			_g_free0 (_tmp4_);
			path = _tmp6_;
			_tmp7_ = desktop_agnostic_vfs_file_new_for_path (path, &_inner_error_);
			_tmp8_ = _tmp7_;
			if (_inner_error_ != NULL) {
				_g_free0 (path);
				_g_object_unref0 (f);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
			_g_object_unref0 (f);
			f = _tmp8_;
			_g_free0 (path);
		}
	}
	result = f;
	return result;
}


static void simple_launcher_create_new_launcher (SimpleLauncher* self) {
	DesktopAgnosticVFSFile* _tmp0_ = NULL;
	DesktopAgnosticVFSFile* f;
	DesktopAgnosticUILauncherEditorDialog* _tmp1_ = NULL;
	DesktopAgnosticUILauncherEditorDialog* d;
	gint _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = simple_launcher_get_new_desktop_file (self);
	f = _tmp0_;
	_tmp1_ = desktop_agnostic_ui_launcher_editor_dialog_new (f, NULL, TRUE);
	d = g_object_ref_sink (_tmp1_);
	gtk_widget_show_all ((GtkWidget*) d);
	_tmp2_ = gtk_dialog_run ((GtkDialog*) d);
	if (_tmp2_ == GTK_RESPONSE_APPLY) {
		gchar* _tmp3_ = NULL;
		GValue _tmp4_ = {0};
		GValue v;
		_tmp3_ = desktop_agnostic_vfs_file_get_path (f);
		g_value_init (&_tmp4_, G_TYPE_STRING);
		g_value_take_string (&_tmp4_, _tmp3_);
		v = _tmp4_;
		g_value_array_append (self->priv->_launcher_list, &v);
		g_object_notify ((GObject*) self, "launcher-list");
		G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
	}
	gtk_object_destroy ((GtkObject*) d);
	_g_object_unref0 (d);
	_g_object_unref0 (f);
}


static gint g_ptr_array_get_length (GPtrArray* self) {
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = (gint) self->len;
	return result;
}


static void g_ptr_array_set_length (GPtrArray* self, gint value) {
	g_return_if_fail (self != NULL);
	g_ptr_array_set_size (self, value);
}


static void _vala_array_add2 (gint** array, int* length, int* size, gint value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gint, *array, *size);
	}
	(*array)[(*length)++] = value;
}


static void simple_launcher_launchers_changed (SimpleLauncher* self) {
	gint i = 0;
	gint* _tmp0_ = NULL;
	gint* invalid_launchers;
	gint invalid_launchers_length1;
	gint _invalid_launchers_size_;
	gint index;
	GList* l;
	gint _tmp24_;
	gboolean something_removed;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_new0 (gint, 0);
	invalid_launchers = _tmp0_;
	invalid_launchers_length1 = 0;
	_invalid_launchers_size_ = 0;
	{
		gboolean _tmp1_;
		i = 0;
		_tmp1_ = TRUE;
		while (TRUE) {
			gint _tmp2_;
			gconstpointer _tmp3_ = NULL;
			if (!_tmp1_) {
				i++;
			}
			_tmp1_ = FALSE;
			_tmp2_ = g_ptr_array_get_length (self->priv->launchers);
			if (!(i < _tmp2_)) {
				break;
			}
			_tmp3_ = g_ptr_array_index (self->priv->launchers, (guint) i);
			g_object_set_data_full ((GObject*) ((AwnThemedIcon*) _tmp3_), "untouched", GINT_TO_POINTER (1), NULL);
		}
	}
	index = 0;
	{
		GValueArray* v_collection;
		guint v_index;
		v_collection = self->priv->_launcher_list;
		for (v_index = 0; v_index < v_collection->n_values; v_index = v_index + 1) {
			GValue _tmp4_ = {0};
			GValue v;
			if (G_IS_VALUE (g_value_array_get_nth (v_collection, v_index))) {
				g_value_init (&_tmp4_, G_VALUE_TYPE (g_value_array_get_nth (v_collection, v_index)));
				g_value_copy (g_value_array_get_nth (v_collection, v_index), &_tmp4_);
			} else {
				_tmp4_ = *g_value_array_get_nth (v_collection, v_index);
			}
			v = _tmp4_;
			{
				const gchar* _tmp5_ = NULL;
				gchar* _tmp6_;
				gchar* de_path;
				gboolean found;
				_tmp5_ = g_value_get_string (&v);
				_tmp6_ = g_strdup (_tmp5_);
				de_path = _tmp6_;
				found = FALSE;
				{
					gboolean _tmp7_;
					i = 0;
					_tmp7_ = TRUE;
					while (TRUE) {
						gint _tmp8_;
						gconstpointer _tmp9_ = NULL;
						gconstpointer _tmp10_ = NULL;
						DesktopAgnosticFDODesktopEntry* _tmp11_;
						DesktopAgnosticFDODesktopEntry* de;
						gboolean _tmp12_ = FALSE;
						if (!_tmp7_) {
							i++;
						}
						_tmp7_ = FALSE;
						_tmp8_ = g_ptr_array_get_length (self->priv->launchers);
						if (!(i < _tmp8_)) {
							break;
						}
						_tmp9_ = g_ptr_array_index (self->priv->launchers, (guint) i);
						_tmp10_ = g_object_get_data ((GObject*) ((AwnThemedIcon*) _tmp9_), SIMPLE_LAUNCHER_DESKTOP_ENTRY);
						_tmp11_ = _g_object_ref0 ((DesktopAgnosticFDODesktopEntry*) _tmp10_);
						de = _tmp11_;
						if (de != NULL) {
							DesktopAgnosticVFSFile* _tmp13_ = NULL;
							gchar* _tmp14_ = NULL;
							gchar* _tmp15_;
							_tmp13_ = desktop_agnostic_fdo_desktop_entry_get_file (de);
							_tmp14_ = desktop_agnostic_vfs_file_get_path (_tmp13_);
							_tmp15_ = _tmp14_;
							_tmp12_ = g_strcmp0 (_tmp15_, de_path) == 0;
							_g_free0 (_tmp15_);
						} else {
							_tmp12_ = FALSE;
						}
						if (_tmp12_) {
							gconstpointer _tmp16_ = NULL;
							gconstpointer _tmp17_ = NULL;
							_tmp16_ = g_ptr_array_index (self->priv->launchers, (guint) i);
							g_object_set_data_full ((GObject*) ((AwnThemedIcon*) _tmp16_), "untouched", GINT_TO_POINTER (0), NULL);
							found = TRUE;
							_tmp17_ = g_ptr_array_index (self->priv->launchers, (guint) i);
							gtk_box_reorder_child ((GtkBox*) self->priv->icon_box, (GtkWidget*) ((AwnThemedIcon*) _tmp17_), index);
							_g_object_unref0 (de);
							break;
						}
						_g_object_unref0 (de);
					}
				}
				if (!found) {
					AwnThemedIcon* _tmp18_ = NULL;
					AwnThemedIcon* icon;
					_tmp18_ = simple_launcher_create_launcher (self, de_path);
					icon = _tmp18_;
					if (icon != NULL) {
						gtk_box_reorder_child ((GtkBox*) self->priv->icon_box, (GtkWidget*) icon, index);
					} else {
						_vala_array_add2 (&invalid_launchers, &invalid_launchers_length1, &_invalid_launchers_size_, index);
					}
					_g_object_unref0 (icon);
				}
				index++;
				_g_free0 (de_path);
				G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
			}
		}
	}
	l = NULL;
	{
		gboolean _tmp19_;
		i = 0;
		_tmp19_ = TRUE;
		while (TRUE) {
			gint _tmp20_;
			gconstpointer _tmp21_ = NULL;
			gconstpointer _tmp22_ = NULL;
			if (!_tmp19_) {
				i++;
			}
			_tmp19_ = FALSE;
			_tmp20_ = g_ptr_array_get_length (self->priv->launchers);
			if (!(i < _tmp20_)) {
				break;
			}
			_tmp21_ = g_ptr_array_index (self->priv->launchers, (guint) i);
			_tmp22_ = g_object_get_data ((GObject*) ((AwnThemedIcon*) _tmp21_), "untouched");
			if (GPOINTER_TO_INT (_tmp22_) != 0) {
				gconstpointer _tmp23_ = NULL;
				_tmp23_ = g_ptr_array_index (self->priv->launchers, (guint) i);
				l = g_list_append (l, (AwnThemedIcon*) _tmp23_);
			}
		}
	}
	{
		GList* ti_collection;
		GList* ti_it;
		ti_collection = l;
		for (ti_it = ti_collection; ti_it != NULL; ti_it = ti_it->next) {
			AwnThemedIcon* ti;
			ti = (AwnThemedIcon*) ti_it->data;
			{
				simple_launcher_remove_launcher (self, ti, TRUE);
			}
		}
	}
	_tmp24_ = g_ptr_array_get_length (self->priv->launchers);
	if (_tmp24_ > 0) {
		gtk_widget_hide ((GtkWidget*) self->priv->add_icon);
	} else {
		gtk_widget_show ((GtkWidget*) self->priv->add_icon);
	}
	something_removed = FALSE;
	{
		gboolean _tmp25_;
		i = invalid_launchers_length1 - 1;
		_tmp25_ = TRUE;
		while (TRUE) {
			if (!_tmp25_) {
				i--;
			}
			_tmp25_ = FALSE;
			if (!(i >= 0)) {
				break;
			}
			g_value_array_remove (self->priv->_launcher_list, (guint) invalid_launchers[i]);
			something_removed = TRUE;
		}
	}
	if (something_removed) {
		g_object_notify ((GObject*) self, "launcher-list");
	}
	_g_list_free0 (l);
	invalid_launchers = (g_free (invalid_launchers), NULL);
}


static void _simple_launcher_on_launcher_clicked_awn_icon_clicked (AwnIcon* _sender, gpointer self) {
	simple_launcher_on_launcher_clicked (self, _sender);
}


static void _simple_launcher_on_launcher_ctx_menu_awn_icon_context_menu_popup (AwnIcon* _sender, GdkEventButton* event, gpointer self) {
	simple_launcher_on_launcher_ctx_menu (self, _sender, event);
}


static gboolean _simple_launcher_on_launcher_drag_motion_gtk_widget_drag_motion (GtkWidget* _sender, GdkDragContext* context, gint x, gint y, guint time_, gpointer self) {
	gboolean result;
	result = simple_launcher_on_launcher_drag_motion (self);
	return result;
}


static AwnThemedIcon* simple_launcher_create_launcher (SimpleLauncher* self, const gchar* path) {
	AwnThemedIcon* result = NULL;
	DesktopAgnosticVFSFile* _tmp0_ = NULL;
	DesktopAgnosticVFSFile* f;
	gboolean _tmp1_;
	DesktopAgnosticFDODesktopEntry* _tmp2_ = NULL;
	DesktopAgnosticFDODesktopEntry* de;
	AwnThemedIcon* _tmp3_ = NULL;
	AwnThemedIcon* icon;
	DesktopAgnosticFDODesktopEntry* _tmp4_;
	gint _tmp5_;
	gchar* _tmp6_;
	gchar* icon_name;
	gboolean _tmp7_;
	const gchar* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	gchar* _tmp12_;
	AwnThemedIcon* _tmp13_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = desktop_agnostic_vfs_file_new_for_path (path, &_inner_error_);
	f = _tmp0_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp1_ = desktop_agnostic_vfs_file_exists (f);
	if (!_tmp1_) {
		g_warning ("simple-launcher.vala:396: Desktop file \"%s\" doesn't exist!", path);
		result = NULL;
		_g_object_unref0 (f);
		return result;
	}
	_tmp2_ = desktop_agnostic_fdo_desktop_entry_new_for_file (f, &_inner_error_);
	de = _tmp2_;
	if (_inner_error_ != NULL) {
		_g_object_unref0 (f);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp3_ = (AwnThemedIcon*) awn_themed_icon_new ();
	icon = g_object_ref_sink (_tmp3_);
	g_object_set (icon, "drag-and-drop", FALSE, NULL);
	_tmp4_ = _g_object_ref0 (de);
	g_object_set_data_full ((GObject*) icon, SIMPLE_LAUNCHER_DESKTOP_ENTRY, _tmp4_, g_object_unref);
	_tmp5_ = awn_applet_get_size ((AwnApplet*) self);
	awn_themed_icon_set_size (icon, _tmp5_);
	_tmp6_ = g_strdup ("image-missing");
	icon_name = _tmp6_;
	_tmp7_ = desktop_agnostic_fdo_desktop_entry_key_exists (de, "Icon");
	if (_tmp7_) {
		gchar* _tmp8_ = NULL;
		_tmp8_ = desktop_agnostic_fdo_desktop_entry_get_string (de, "Icon");
		_g_free0 (icon_name);
		icon_name = _tmp8_;
	}
	_tmp9_ = awn_applet_get_canonical_name ((AwnApplet*) self);
	_tmp10_ = awn_applet_get_uid ((AwnApplet*) self);
	awn_themed_icon_set_info_simple (icon, _tmp9_, _tmp10_, icon_name);
	_tmp11_ = desktop_agnostic_fdo_desktop_entry_get_localestring (de, "Name", NULL);
	_tmp12_ = _tmp11_;
	awn_icon_set_tooltip_text ((AwnIcon*) icon, _tmp12_);
	_g_free0 (_tmp12_);
	g_signal_connect_object ((AwnIcon*) icon, "clicked", (GCallback) _simple_launcher_on_launcher_clicked_awn_icon_clicked, self, 0);
	g_signal_connect_object ((AwnIcon*) icon, "context-menu-popup", (GCallback) _simple_launcher_on_launcher_ctx_menu_awn_icon_context_menu_popup, self, 0);
	gtk_container_add ((GtkContainer*) self->priv->icon_box, (GtkWidget*) icon);
	gtk_widget_show ((GtkWidget*) icon);
	gtk_drag_dest_set ((GtkWidget*) icon, 0, NULL, 0, GDK_ACTION_PRIVATE);
	g_signal_connect_object ((GtkWidget*) icon, "drag-motion", (GCallback) _simple_launcher_on_launcher_drag_motion_gtk_widget_drag_motion, self, 0);
	_tmp13_ = _g_object_ref0 (icon);
	g_ptr_array_add (self->priv->launchers, _tmp13_);
	result = icon;
	_g_free0 (icon_name);
	_g_object_unref0 (de);
	_g_object_unref0 (f);
	return result;
}


static void simple_launcher_remove_launcher (SimpleLauncher* self, AwnThemedIcon* launcher, gboolean delete_desktop_file) {
	gpointer _tmp0_ = NULL;
	DesktopAgnosticFDODesktopEntry* de;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (launcher != NULL);
	_tmp0_ = g_object_steal_data ((GObject*) launcher, SIMPLE_LAUNCHER_DESKTOP_ENTRY);
	de = (DesktopAgnosticFDODesktopEntry*) _tmp0_;
	if (delete_desktop_file) {
		DesktopAgnosticVFSFile* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		gboolean _tmp5_;
		_tmp2_ = desktop_agnostic_fdo_desktop_entry_get_file (de);
		_tmp3_ = desktop_agnostic_vfs_file_get_path (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_str_has_prefix (_tmp4_, self->priv->config_dir);
		_tmp1_ = _tmp5_;
		_g_free0 (_tmp4_);
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		DesktopAgnosticVFSFile* _tmp6_ = NULL;
		_tmp6_ = desktop_agnostic_fdo_desktop_entry_get_file (de);
		desktop_agnostic_vfs_file_remove (_tmp6_, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_object_unref0 (de);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	g_ptr_array_remove (self->priv->launchers, launcher);
	gtk_object_destroy ((GtkObject*) launcher);
	_g_object_unref0 (de);
}


static gboolean _lambda0_ (SimpleLauncher* self) {
	gboolean result = FALSE;
	gtk_widget_hide ((GtkWidget*) self->priv->add_icon);
	result = FALSE;
	return result;
}


static gboolean __lambda0__gsource_func (gpointer self) {
	gboolean result;
	result = _lambda0_ (self);
	return result;
}


static gboolean simple_launcher_on_launcher_drag_motion (SimpleLauncher* self) {
	gboolean result = FALSE;
	guint _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	if (self->priv->timer_id != 0) {
		g_source_remove (self->priv->timer_id);
	}
	_tmp0_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 2500, __lambda0__gsource_func, g_object_ref (self), g_object_unref);
	self->priv->timer_id = _tmp0_;
	gtk_widget_show ((GtkWidget*) self->priv->add_icon);
	result = FALSE;
	return result;
}


static void simple_launcher_on_launcher_clicked (SimpleLauncher* self, AwnIcon* launcher) {
	gconstpointer _tmp0_ = NULL;
	DesktopAgnosticFDODesktopEntry* _tmp1_;
	DesktopAgnosticFDODesktopEntry* de;
	AwnEffects* _tmp2_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (launcher != NULL);
	_tmp0_ = g_object_get_data ((GObject*) launcher, SIMPLE_LAUNCHER_DESKTOP_ENTRY);
	_tmp1_ = _g_object_ref0 ((DesktopAgnosticFDODesktopEntry*) _tmp0_);
	de = _tmp1_;
	g_return_if_fail (de != NULL);
	desktop_agnostic_fdo_desktop_entry_launch (de, 0, NULL, &_inner_error_);
	if (_inner_error_ != NULL) {
		goto __catch1_g_error;
	}
	_tmp2_ = awn_overlayable_get_effects ((AwnOverlayable*) launcher);
	awn_effects_start_ex (_tmp2_, AWN_EFFECT_LAUNCHING, 1, FALSE, FALSE);
	goto __finally1;
	__catch1_g_error:
	{
		GError * err;
		GtkMessageDialog* _tmp3_ = NULL;
		GtkMessageDialog* d;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = (GtkMessageDialog*) gtk_message_dialog_new (NULL, GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, "Unable to start launcher!\n\n" "Error details:\n%s", err->message);
		d = g_object_ref_sink (_tmp3_);
		gtk_dialog_run ((GtkDialog*) d);
		gtk_object_destroy ((GtkObject*) d);
		_g_object_unref0 (d);
		_g_error_free0 (err);
	}
	__finally1:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (de);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_object_unref0 (de);
}


static void simple_launcher_on_launcher_ctx_menu (SimpleLauncher* self, AwnIcon* launcher, GdkEventButton* event) {
	AwnIcon* _tmp0_;
	AwnIcon* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (launcher != NULL);
	_tmp0_ = _g_object_ref0 (launcher);
	g_object_set_data_full ((GObject*) self->priv->remove_menu_item, SIMPLE_LAUNCHER_DESKTOP_ENTRY, _tmp0_, g_object_unref);
	_tmp1_ = _g_object_ref0 (launcher);
	g_object_set_data_full ((GObject*) self->priv->edit_menu_item, SIMPLE_LAUNCHER_DESKTOP_ENTRY, _tmp1_, g_object_unref);
	awn_icon_popup_gtk_menu (launcher, (GtkWidget*) self->priv->menu, (*event).button, (*event).time);
}


static void simple_launcher_remove_clicked (SimpleLauncher* self) {
	gconstpointer _tmp0_ = NULL;
	AwnThemedIcon* _tmp1_;
	AwnThemedIcon* ti;
	gconstpointer _tmp2_ = NULL;
	DesktopAgnosticFDODesktopEntry* _tmp3_;
	DesktopAgnosticFDODesktopEntry* de;
	guint index;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_object_get_data ((GObject*) self->priv->remove_menu_item, SIMPLE_LAUNCHER_DESKTOP_ENTRY);
	_tmp1_ = _g_object_ref0 ((AwnThemedIcon*) _tmp0_);
	ti = _tmp1_;
	_tmp2_ = g_object_get_data ((GObject*) ti, SIMPLE_LAUNCHER_DESKTOP_ENTRY);
	_tmp3_ = _g_object_ref0 ((DesktopAgnosticFDODesktopEntry*) _tmp2_);
	de = _tmp3_;
	index = (guint) 0;
	{
		GValueArray* v_collection;
		guint v_index;
		v_collection = self->priv->_launcher_list;
		for (v_index = 0; v_index < v_collection->n_values; v_index = v_index + 1) {
			GValue _tmp4_ = {0};
			GValue v;
			if (G_IS_VALUE (g_value_array_get_nth (v_collection, v_index))) {
				g_value_init (&_tmp4_, G_VALUE_TYPE (g_value_array_get_nth (v_collection, v_index)));
				g_value_copy (g_value_array_get_nth (v_collection, v_index), &_tmp4_);
			} else {
				_tmp4_ = *g_value_array_get_nth (v_collection, v_index);
			}
			v = _tmp4_;
			{
				const gchar* _tmp5_ = NULL;
				DesktopAgnosticVFSFile* _tmp6_ = NULL;
				gchar* _tmp7_ = NULL;
				gchar* _tmp8_;
				gboolean _tmp9_;
				_tmp5_ = g_value_get_string (&v);
				_tmp6_ = desktop_agnostic_fdo_desktop_entry_get_file (de);
				_tmp7_ = desktop_agnostic_vfs_file_get_path (_tmp6_);
				_tmp8_ = _tmp7_;
				_tmp9_ = g_strcmp0 (_tmp5_, _tmp8_) == 0;
				_g_free0 (_tmp8_);
				if (_tmp9_) {
					G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
					break;
				}
				index++;
				G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
			}
		}
	}
	if (index < self->priv->_launcher_list->n_values) {
		g_value_array_remove (self->priv->_launcher_list, index);
	}
	g_object_notify ((GObject*) self, "launcher-list");
	_g_object_unref0 (de);
	_g_object_unref0 (ti);
}


static void simple_launcher_edit_clicked (SimpleLauncher* self) {
	gconstpointer _tmp0_ = NULL;
	AwnThemedIcon* _tmp1_;
	AwnThemedIcon* ti;
	gconstpointer _tmp2_ = NULL;
	DesktopAgnosticFDODesktopEntry* _tmp3_;
	DesktopAgnosticFDODesktopEntry* de;
	DesktopAgnosticVFSFile* _tmp4_ = NULL;
	DesktopAgnosticVFSFile* _tmp5_;
	DesktopAgnosticVFSFile* input;
	DesktopAgnosticVFSFile* output;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	DesktopAgnosticUILauncherEditorDialog* _tmp11_ = NULL;
	DesktopAgnosticUILauncherEditorDialog* d;
	gint _tmp12_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_object_get_data ((GObject*) self->priv->remove_menu_item, SIMPLE_LAUNCHER_DESKTOP_ENTRY);
	_tmp1_ = _g_object_ref0 ((AwnThemedIcon*) _tmp0_);
	ti = _tmp1_;
	_tmp2_ = g_object_get_data ((GObject*) ti, SIMPLE_LAUNCHER_DESKTOP_ENTRY);
	_tmp3_ = _g_object_ref0 ((DesktopAgnosticFDODesktopEntry*) _tmp2_);
	de = _tmp3_;
	_tmp4_ = desktop_agnostic_fdo_desktop_entry_get_file (de);
	_tmp5_ = _g_object_ref0 (_tmp4_);
	input = _tmp5_;
	output = NULL;
	_tmp6_ = desktop_agnostic_vfs_file_get_path (input);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_str_has_prefix (_tmp7_, self->priv->config_dir);
	_tmp9_ = !_tmp8_;
	_g_free0 (_tmp7_);
	if (_tmp9_) {
		DesktopAgnosticVFSFile* _tmp10_ = NULL;
		_tmp10_ = simple_launcher_get_new_desktop_file (self);
		_g_object_unref0 (output);
		output = _tmp10_;
	}
	_tmp11_ = desktop_agnostic_ui_launcher_editor_dialog_new (input, output, TRUE);
	d = g_object_ref_sink (_tmp11_);
	gtk_widget_show_all ((GtkWidget*) d);
	_tmp12_ = gtk_dialog_run ((GtkDialog*) d);
	if (_tmp12_ == GTK_RESPONSE_APPLY) {
		if (output == NULL) {
			simple_launcher_remove_launcher (self, ti, FALSE);
			simple_launcher_launchers_changed (self);
		} else {
			GValue* val = NULL;
			{
				guint i;
				i = (guint) 0;
				{
					gboolean _tmp13_;
					_tmp13_ = TRUE;
					while (TRUE) {
						GValue* _tmp14_ = NULL;
						const gchar* _tmp15_ = NULL;
						gchar* _tmp16_ = NULL;
						gchar* _tmp17_;
						gboolean _tmp18_;
						if (!_tmp13_) {
							i++;
						}
						_tmp13_ = FALSE;
						if (!(i < self->priv->_launcher_list->n_values)) {
							break;
						}
						_tmp14_ = g_value_array_get_nth (self->priv->_launcher_list, i);
						val = _tmp14_;
						_tmp15_ = g_value_get_string (val);
						_tmp16_ = desktop_agnostic_vfs_file_get_path (input);
						_tmp17_ = _tmp16_;
						_tmp18_ = g_strcmp0 (_tmp15_, _tmp17_) == 0;
						_g_free0 (_tmp17_);
						if (_tmp18_) {
							gchar* _tmp19_ = NULL;
							gchar* _tmp20_;
							_tmp19_ = desktop_agnostic_vfs_file_get_path (output);
							_tmp20_ = _tmp19_;
							g_value_set_string (val, _tmp20_);
							_g_free0 (_tmp20_);
						}
					}
				}
			}
			g_object_notify ((GObject*) self, "launcher-list");
		}
	}
	gtk_object_destroy ((GtkObject*) d);
	_g_object_unref0 (d);
	_g_object_unref0 (output);
	_g_object_unref0 (input);
	_g_object_unref0 (de);
	_g_object_unref0 (ti);
}


GValueArray* simple_launcher_get_launcher_list (SimpleLauncher* self) {
	GValueArray* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_launcher_list;
	return result;
}


void simple_launcher_set_launcher_list (SimpleLauncher* self, GValueArray* value) {
	GValueArray* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_value_array_copy (value);
	_g_value_array_free0 (self->priv->_launcher_list);
	self->priv->_launcher_list = _tmp0_;
	g_object_notify ((GObject *) self, "launcher-list");
}


static GObject * simple_launcher_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	SimpleLauncher * self;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	GPtrArray* _tmp2_ = NULL;
	DesktopAgnosticConfigClient* _tmp3_ = NULL;
	DesktopAgnosticConfigClient* _tmp4_;
	DesktopAgnosticConfigClient* _tmp5_;
	GError * _inner_error_ = NULL;
	parent_class = G_OBJECT_CLASS (simple_launcher_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = SIMPLE_LAUNCHER (obj);
	_tmp0_ = g_get_user_config_dir ();
	_tmp1_ = g_build_filename (_tmp0_, "awn", "applets", "simple-launcher", NULL, NULL);
	_g_free0 (self->priv->config_dir);
	self->priv->config_dir = _tmp1_;
	g_mkdir_with_parents (self->priv->config_dir, 0755);
	_tmp2_ = g_ptr_array_new_with_free_func (_g_object_unref0_);
	_g_ptr_array_unref0 (self->priv->launchers);
	self->priv->launchers = _tmp2_;
	_tmp3_ = awn_config_get_default_for_applet ((AwnApplet*) self, &_inner_error_);
	_tmp4_ = _tmp3_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
	}
	_tmp5_ = _g_object_ref0 (_tmp4_);
	_g_object_unref0 (self->priv->client);
	self->priv->client = _tmp5_;
	desktop_agnostic_config_client_bind (self->priv->client, DESKTOP_AGNOSTIC_CONFIG_GROUP_DEFAULT, "launcher_list", (GObject*) self, "launcher-list", FALSE, DESKTOP_AGNOSTIC_CONFIG_BIND_METHOD_FALLBACK, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == DESKTOP_AGNOSTIC_CONFIG_ERROR) {
			goto __catch2_desktop_agnostic_config_error;
		}
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
	}
	goto __finally2;
	__catch2_desktop_agnostic_config_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		g_critical ("simple-launcher.vala:157: Config Error: %s", err->message);
		_g_error_free0 (err);
	}
	__finally2:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
	}
	return obj;
}


static void simple_launcher_class_init (SimpleLauncherClass * klass) {
	simple_launcher_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SimpleLauncherPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_simple_launcher_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_simple_launcher_set_property;
	G_OBJECT_CLASS (klass)->constructor = simple_launcher_constructor;
	G_OBJECT_CLASS (klass)->finalize = simple_launcher_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIMPLE_LAUNCHER_LAUNCHER_LIST, g_param_spec_boxed ("launcher-list", "launcher-list", "launcher-list", G_TYPE_VALUE_ARRAY, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void simple_launcher_instance_init (SimpleLauncher * self) {
	GValueArray* _tmp0_ = NULL;
	self->priv = SIMPLE_LAUNCHER_GET_PRIVATE (self);
	self->priv->timer_id = (guint) 0;
	_tmp0_ = g_value_array_new ((guint) 4);
	self->priv->_launcher_list = _tmp0_;
}


static void simple_launcher_finalize (GObject* obj) {
	SimpleLauncher * self;
	self = SIMPLE_LAUNCHER (obj);
	_g_object_unref0 (self->priv->icon_box);
	_g_object_unref0 (self->priv->add_icon);
	_g_object_unref0 (self->priv->menu);
	_g_object_unref0 (self->priv->add_icon_menu);
	_g_object_unref0 (self->priv->remove_menu_item);
	_g_object_unref0 (self->priv->edit_menu_item);
	_g_object_unref0 (self->priv->client);
	_g_free0 (self->priv->config_dir);
	_g_ptr_array_unref0 (self->priv->launchers);
	_g_value_array_free0 (self->priv->_launcher_list);
	G_OBJECT_CLASS (simple_launcher_parent_class)->finalize (obj);
}


GType simple_launcher_get_type (void) {
	static volatile gsize simple_launcher_type_id__volatile = 0;
	if (g_once_init_enter (&simple_launcher_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SimpleLauncherClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) simple_launcher_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SimpleLauncher), 0, (GInstanceInitFunc) simple_launcher_instance_init, NULL };
		GType simple_launcher_type_id;
		simple_launcher_type_id = g_type_register_static (AWN_TYPE_APPLET, "SimpleLauncher", &g_define_type_info, 0);
		g_once_init_leave (&simple_launcher_type_id__volatile, simple_launcher_type_id);
	}
	return simple_launcher_type_id__volatile;
}


static void _vala_simple_launcher_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SimpleLauncher * self;
	self = SIMPLE_LAUNCHER (object);
	switch (property_id) {
		case SIMPLE_LAUNCHER_LAUNCHER_LIST:
		g_value_set_boxed (value, simple_launcher_get_launcher_list (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_simple_launcher_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SimpleLauncher * self;
	self = SIMPLE_LAUNCHER (object);
	switch (property_id) {
		case SIMPLE_LAUNCHER_LAUNCHER_LIST:
		simple_launcher_set_launcher_list (self, g_value_get_boxed (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


AwnApplet* awn_applet_factory_initp (const gchar* canonical_name, const gchar* uid, gint panel_id) {
	AwnApplet* result = NULL;
	SimpleLauncher* _tmp0_ = NULL;
	g_return_val_if_fail (canonical_name != NULL, NULL);
	g_return_val_if_fail (uid != NULL, NULL);
	_tmp0_ = simple_launcher_new (canonical_name, uid, panel_id);
	result = (AwnApplet*) g_object_ref_sink (_tmp0_);
	return result;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



